/*

 65c816 opcodes 0x10-0x1F:
    10: BPL r       2,2
    11: ORA (d),y   2,5
    12: ORA (d)     2,5
    13: ORA (d,s),y 2,7
    14: TRB d       2,5
    15: ORA d,x     2,4
    16: ASL d,x     2,6
    17: ORA [d],y   2,6
    18: CLC i       1,2
    19: ORA a,y     3,4
    1A: INC A       1,2
    1B: TCS i       1,2
    1C: TRB a       3,6
    1D: ORA a,x     3,4
    1E: ASL a,x     3,7
    1F: ORA al,x    4,5
*/

/* 10 */
BFC BPL,SNES_FLAG_N

/* 11 */
EM_ORA OdO_y,Direct_Indirect_Indexed
E0_ORA OdO_y,Direct_Indirect_Indexed

/* 12 */
EM_ORA OdO,Direct_Indirect
E0_ORA OdO,Direct_Indirect

/* 13 */
EM_ORA Od_sO_y,Stack_Relative_Indirect_Indexed
E0_ORA Od_sO_y,Stack_Relative_Indirect_Indexed

/* 14 */
EM_TRB d,Direct
E0_TRB d,Direct

/* 15 */
EM_ORA d_x,Direct_Index_X
E0_ORA d_x,Direct_Index_X

/* 16 */
EM_ASL d_x,Direct_Index_X
E0_ASL d_x,Direct_Index_X

/* 17 */
EM_ORA IdI_y,Direct_Indirect_Indexed_Long
E0_ORA IdI_y,Direct_Indirect_Indexed_Long

/* 18 */

ALIGNC
ALL_CLC:
    incl _NativePC
    CLR_FLAG SNES_FLAG_C
    jmp CPU_RETURN

/* 19 */
EM_ORA a_y,Absolute_Index_Y
E0_ORA a_y,Absolute_Index_Y

/* 1A */

ALIGNC
EM_INA:
    incl _NativePC
    incb R_A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_INA:
    incl _NativePC
    incw R_A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 1B */

ALIGNC
E0_TCS:
    incl _NativePC
    movl R_A,%eax
    movl %eax,R_S
    jmp CPU_RETURN
ALIGNC
E1_TCS:
    incl _NativePC
    movb R_A,%al
    movb %al,R_S
    jmp CPU_RETURN

/* 1C */
EM_TRB a,Absolute
E0_TRB a,Absolute

/* 1D */
EM_ORA a_x,Absolute_Index_X
E0_ORA a_x,Absolute_Index_X

/* 1E */
EM_ASL a_x,Absolute_Index_X
E0_ASL a_x,Absolute_Index_X

/* 1F */
EM_ORA al_x,Absolute_Long_Index_X
E0_ORA al_x,Absolute_Long_Index_X
