/*

 65c816 opcodes 0x20-0x2F:
    20: JSR a       3,6
    21: ORA (d,x)   2,6
    22: JSL al      4,8
    23: AND d,s     2,4
    24: BIT d       2,3
    25: AND d       2,3
    26: ROL d       2,5
    27: AND [d]     2,6
    28: PLP s       1,4
    29: AND #       2,2
    2A: ROL a       1,2
    2B: PLD s       1,5
    2C: BIT a       3,4
    2D: AND a       3,4
    2E: ROL a       3,6
    2F: AND al      4,5
*/

/* 20 */

ALIGNC
E0_JSR_a:
    GET_PC %eax
    addl $2,%eax        // last instruction byte PC in ax
    E0_PUSH_W           // Address of last byte not next instruction (huh!)
    ADDR_Absolute_JMP
    xorl %ebx,%ebx
    movl %eax,_NativePC
    movb R_PB,%bl
    addb %ah,%ah
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

ALIGNC
E1_JSR_a:
    GET_PC %eax
    addl $2,%eax        // last instruction byte PC in ax
    E1_PUSH_W           // Address of last byte not next instruction (huh!)
    ADDR_Absolute_JMP
    xorl %ebx,%ebx
    movl %eax,_NativePC
    movb R_PB,%bl
    addb %ah,%ah
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

/* 21 */
EM_AND Od_xO,Direct_Indexed_Indirect
E0_AND Od_xO,Direct_Indexed_Indirect

/* 22 */

ALIGNC
E0_JSL_al:              // JSR Absolute long address
    movb R_PB,%al
    E0_PUSH_B           // Push PB
    GET_PC %eax
    addl $3,%eax        // Address of last byte of instruction
    E0_PUSH_W           // Push PC

    movb 1(_NativePC),%al
    xorl %ebx,%ebx
    movb 2(_NativePC),%ah
    movb 3(_NativePC),%bl
    movl %eax,_NativePC
    movb %bl,_PB
    testb %bl,MEMSEL    // Check bus speed against PB
    movb $5,%al
    jnz 0f
    movb $4,%al
0:  addb %ah,%ah
    movb %al,CycleTable // Update bus speed
    movl _Read_BankMapping(,%ebx,4),%eax
    adcl %ebx,%ebx
    movl %eax,R_PB_Read
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

ALIGNC
E1_JSL_al:
    movb R_PB,%al
    E1_PUSH_B           // Push PB
    GET_PC %eax
    addl $3,%eax        // Address of last byte of instruction
    E1_PUSH_W           // Push PC

    movb 1(_NativePC),%al
    xorl %ebx,%ebx
    movb 2(_NativePC),%ah
    movb 3(_NativePC),%bl
    movl %eax,_NativePC
    movb %bl,R_PB
    testb %bl,MEMSEL    // Check bus speed against PB
    movb $5,%al
    jnz 0f
    movb $4,%al
0:  addb %ah,%ah
    movb %al,CycleTable // Update bus speed
    movl _Read_BankMapping(,%ebx,4),%eax
    adcl %ebx,%ebx
    movl %eax,R_PB_Read
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

/* 23 */
EM_AND d_s,Stack_Relative
E0_AND d_s,Stack_Relative

/* 24 */
EM_BIT d,Direct
E0_BIT d,Direct

/* 25 */
EM_AND d,Direct
E0_AND d,Direct

/* 26 */
EM_ROL d,Direct
E0_ROL d,Direct

/* 27 */
EM_AND IdI,Direct_Indirect_Long
E0_AND IdI,Direct_Indirect_Long

/* 28 */

ALIGNC
E0_PLP:
    incl _NativePC
    E0_PULL_B
    E0_RESTOREFLAGS

    JUMP_FLAG SNES_FLAG_I,0f
    movb IRQ_pin,%al
    testb %al,%al
    jz  0f
    SAVE_PC %ebx
    addl $60,_Cycles    // IRQ processing: 2 IO + 6 bank0
    call E0_IRQ
    LOAD_PC
0:
    SET_TABLE_MX
ALIGNC
E1_PLP:
    incl _NativePC
    E1_PULL_B
    E1_RESTOREFLAGS

    JUMP_FLAG SNES_FLAG_I,CPU_RETURN
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    SAVE_PC %ebx
    addl $52,_Cycles    // IRQ processing: 2 IO + 5 bank0
    call E1_IRQ
    LOAD_PC
    jmp CPU_RETURN

/* 29 */
EM_AND i,Immediate
E0_AND i,Immediate

/* 2A */

ALIGNC
EM_RLA:
    incl _NativePC
    movb R_A,%al
    MAKE_CARRY
    adcb %al,%al
    movb %al,R_A
    STORE_FLAGS (SNES_FLAG_NZC)
    jmp CPU_RETURN

ALIGNC
E0_RLA:
    incl _NativePC
    movl R_A,%eax
    MAKE_CARRY
    adcw %ax,%ax
    movl %eax,R_A
    STORE_FLAGS (SNES_FLAG_NZC)
    jmp CPU_RETURN

/* 2B */

ALIGNC
E0_PLD:
    incl _NativePC
    E0_PULL_W
    movl %eax,R_D
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E1_PLD:
    incl _NativePC
    E1_PULL_W
    movl %eax,R_D
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 2C */
EM_BIT a,Absolute
E0_BIT a,Absolute

/* 2D */
EM_AND a,Absolute
E0_AND a,Absolute

/* 2E */
EM_ROL a,Absolute
E0_ROL a,Absolute

/* 2F */
EM_AND al,Absolute_Long
E0_AND al,Absolute_Long
