/*

 65c816 opcodes 0x30-0x3F:
    30: BMI r       2,2
    31: AND (d),y   2,5
    32: AND (d)     2,5
    33: AND (d,s),y 2,7
    34: BIT d,x     2,4
    35: AND d,x     2,4
    36: ROL d,x     2,6
    37: AND [d],y   2,6
    38: SEC i       1,2
    39: AND a,y     3,4
    3A: DEC A       1,2
    3B: TSC i       1,2
    3C: BIT a,x     3,4
    3D: AND a,x     3,4
    3E: ROL a,x     3,7
    3F: AND al,x    4,5
*/

/* 30 */
BFS BMI,SNES_FLAG_N

/* 31 */
EM_AND OdO_y,Direct_Indirect_Indexed
E0_AND OdO_y,Direct_Indirect_Indexed

/* 32 */
EM_AND OdO,Direct_Indirect
E0_AND OdO,Direct_Indirect

/* 33 */
EM_AND Od_sO_y,Stack_Relative_Indirect_Indexed
E0_AND Od_sO_y,Stack_Relative_Indirect_Indexed

/* 34 */
EM_BIT d_x,Direct_Index_X
E0_BIT d_x,Direct_Index_X

/* 35 */
EM_AND d_x,Direct_Index_X
E0_AND d_x,Direct_Index_X

/* 36 */
EM_ROL d_x,Direct_Index_X
E0_ROL d_x,Direct_Index_X

/* 37 */
EM_AND IdI_y,Direct_Indirect_Indexed_Long
E0_AND IdI_y,Direct_Indirect_Indexed_Long

/* 38 */

ALIGNC
ALL_SEC:			/* Set Carry Flag */
    incl _NativePC
    SET_FLAG SNES_FLAG_C
    jmp CPU_RETURN

/* 39 */
EM_AND a_y,Absolute_Index_Y
E0_AND a_y,Absolute_Index_Y

/* 3A */

ALIGNC
EM_DEA:
    incl _NativePC
    decb R_A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_DEA:
    incl _NativePC
    decw R_A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 3B */

ALIGNC
ALL_TSC:
    incl _NativePC
    movl R_S,%eax
    movl %eax,R_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 3C */
EM_BIT a_x,Absolute_Index_X
E0_BIT a_x,Absolute_Index_X

/* 3D */
EM_AND a_x,Absolute_Index_X
E0_AND a_x,Absolute_Index_X

/* 3E */
EM_ROL a_x,Absolute_Index_X
E0_ROL a_x,Absolute_Index_X

/* 3F */
EM_AND al_x,Absolute_Long_Index_X
E0_AND al_x,Absolute_Long_Index_X
