/*

 65c816 opcodes 0x50-0x5F:
    50: BVC r       2,2
    51: EOR (d),y   2,5
    52: EOR (d)     2,5
    53: EOR (d,s),y 2,7
    54: MVN xya     3,7
    55: EOR d,x     2,4
    56: LSR d,x     2,6
    57: EOR [d],y   2,6
    58: CLI i       1,2
    59: EOR a,y     3,4
    5A: PHY s       1,2
    5B: TCD i       1,2
    5C: JML al      4,4
    5D: EOR a,x     3,4
    5E: LSR a,x     3,7
    5F: EOR al,x    4,5
*/

/* 50 */
BFC BVC,SNES_FLAG_V

/* 51 */
EM_EOR OdO_y,Direct_Indirect_Indexed
E0_EOR OdO_y,Direct_Indirect_Indexed

/* 52 */
EM_EOR OdO,Direct_Indirect
E0_EOR OdO,Direct_Indirect

/* 53 */
EM_EOR Od_sO_y,Stack_Relative_Indirect_Indexed
E0_EOR Od_sO_y,Stack_Relative_Indirect_Indexed

/* 54 */

ALIGNC
E0_MVN:
    pushl %ebx          // Cycles per instruction iteration
0:  movb 1(_NativePC),%al   // Dest bank
    movb 2(_NativePC),%bl   // Src bank
    movb %al,R_DB
    movw R_X,%ax        // Src address
    shll $16,%ebx
    addl %eax,%ebx
    incl %eax
    movw %ax,R_X
    GET_BYTE
    movl R_DB_Shifted,%ebx
    movw R_Y,%bx        // Dest address
    SET_BYTE
    movl R_A,%eax
    incl %ebx
    subl $1,%eax
    movw %bx,R_Y
    jc  0f
    cmpl _Cycles,R_EventTrip
    jae 1f
    movw %ax,R_A
    addl (%esp),_Cycles
    xorl %eax,%eax
    xorl %ebx,%ebx
    jmp 0b
ALIGNC
0:  addl $3,_NativePC
1:  movw %ax,R_A
    popl %edi
    jmp CPU_RETURN
	
ALIGNC
EX_MVN:
    pushl %ebx          // Cycles per instruction iteration
0:  movb 1(_NativePC),%al   // Dest bank
    movb 2(_NativePC),%bl   // Src bank
    movb %al,R_DB
    movb R_X,%al        // Src address
    shll $16,%ebx
    addl %eax,%ebx
    incl %eax
    movb %al,R_X
    GET_BYTE
    movl R_DB_Shifted,%ebx
    movb R_Y,%bl        // Dest address
    SET_BYTE
    movl R_A,%eax
    incl %ebx
    subl $1,%eax
    movb %bl,R_Y
    jc  0f
    cmpl _Cycles,R_EventTrip
    jae 1f
    movw %ax,R_A
    addl (%esp),_Cycles
    xorl %eax,%eax
    xorl %ebx,%ebx
    jmp 0b
ALIGNC
0:  addl $3,_NativePC
1:  movw %ax,R_A
    popl %edi
    jmp CPU_RETURN

/* 55 */
EM_EOR d_x,Direct_Index_X
E0_EOR d_x,Direct_Index_X

/* 56 */
EM_LSR d_x,Direct_Index_X
E0_LSR d_x,Direct_Index_X

/* 57 */
EM_EOR IdI_y,Direct_Indirect_Indexed_Long
E0_EOR IdI_y,Direct_Indirect_Indexed_Long

/* 58 */

ALIGNC
E0_CLI:
    incl _NativePC
    CLR_FLAG SNES_FLAG_I
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    SAVE_PC %ebx
    addl $60,_Cycles    // IRQ processing: 2 IO + 6 bank0
    call E0_IRQ
    LOAD_PC
    jmp CPU_RETURN

ALIGNC
E1_CLI:
    incl _NativePC
    CLR_FLAG SNES_FLAG_I
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    SAVE_PC %ebx
    addl $52,_Cycles    // IRQ processing: 2 IO + 5 bank0
    call E1_IRQ
    LOAD_PC
    jmp CPU_RETURN

/* 59 */
EM_EOR a_y,Absolute_Index_Y
E0_EOR a_y,Absolute_Index_Y

/* 5A */

ALIGNC
E0_PHY:
    incl _NativePC
    movl R_Y,%eax
	E0_PUSH_W
    jmp CPU_RETURN

ALIGNC
EX_PHY:
    incl _NativePC
    movl R_Y,%eax
	E0_PUSH_B
    jmp CPU_RETURN

ALIGNC
E1_PHY:
    incl _NativePC
    movl R_Y,%eax
	E1_PUSH_B
    jmp CPU_RETURN

/* 5B */

ALIGNC
ALL_TCD:
    incl _NativePC
    movl R_A,%eax
    movl %eax,R_D
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 5C */

ALIGNC
ALL_JML_al:
    movb 1(_NativePC),%al
    movb 3(_NativePC),%bl
    movb 2(_NativePC),%ah
    movb %bl,R_PB
    movl %eax,_NativePC
    testb %bl,MEMSEL    // Check bus speed against PB
    movb $5,%al
    jnz 0f
    movb $4,%al
0:  addb %ah,%ah
    movb %al,CycleTable // Update bus speed
    movl _Read_BankMapping(,%ebx,4),%eax
    adcl %ebx,%ebx
    movl %eax,R_PB_Read
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

/* 5D */
EM_EOR a_x,Absolute_Index_X
E0_EOR a_x,Absolute_Index_X

/* 5E */
EM_LSR a_x,Absolute_Index_X
E0_LSR a_x,Absolute_Index_X

/* 5F */
EM_EOR al_x,Absolute_Long_Index_X
E0_EOR al_x,Absolute_Long_Index_X
