/*

 65c816 opcodes 0x70-0x7F:
    70: BVS r       2,2
    71: ADC (d),y   2,5
    72: ADC (d)     2,5
    73: ADC (d,s),y 2,7
    74: STZ d,x     2,4
    75: ADC d,x     2,4
    76: ROR d,x     2,6
    77: EOR [d],y   2,6
    78: SEI i       1,2
    79: ADC a,y     3,4
    7A: PLY s       1,4
    7B: TDC i       1,2
    7C: JMP (a,x)   3,6
    7D: ADC a,x     3,4
    7E: ROR a,x     3,7
    7F: ADC al,x    4,5
*/

/* 70 */
BFS BVS,SNES_FLAG_V

/* 71 */
EM_ADC OdO_y,Direct_Indirect_Indexed
E0_ADC OdO_y,Direct_Indirect_Indexed

/* 72 */
EM_ADC OdO,Direct_Indirect
E0_ADC OdO,Direct_Indirect

/* 73 */
EM_ADC Od_sO_y,Stack_Relative_Indirect_Indexed
E0_ADC Od_sO_y,Stack_Relative_Indirect_Indexed

/* 74 */
EM_STZ d_x,Direct_Index_X
E0_STZ d_x,Direct_Index_X

/* 75 */
EM_ADC d_x,Direct_Index_X
E0_ADC d_x,Direct_Index_X

/* 76 */
EM_ROR d_x,Direct_Index_X
E0_ROR d_x,Direct_Index_X

/* 77 */
EM_ADC IdI_y,Direct_Indirect_Indexed_Long
E0_ADC IdI_y,Direct_Indirect_Indexed_Long

/* 78 */

ALIGNC
ALL_SEI:
    incl _NativePC
    SET_FLAG SNES_FLAG_I
    jmp CPU_RETURN

/* 79 */
EM_ADC a_y,Absolute_Index_Y
E0_ADC a_y,Absolute_Index_Y

/* 7A */

ALIGNC
E0_PLY:
    incl _NativePC
    E0_PULL_W
    movl %eax,R_Y
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
EX_PLY:
    incl _NativePC
    E0_PULL_B
    movb %al,R_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E1_PLY:
    incl _NativePC
    E1_PULL_B
    movb %al,R_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 7B */

ALIGNC
ALL_TDC:
    incl _NativePC
    movl R_D,%eax
    movl %eax,R_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 7C */

ALIGNC
ALL_JMP_Oa_xO:
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    movl %eax,_NativePC
    movb R_PB,%bl
    addb %ah,%ah
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

/* 7D */
EM_ADC a_x,Absolute_Index_X
E0_ADC a_x,Absolute_Index_X

/* 7E */
EM_ROR a_x,Absolute_Index_X
E0_ROR a_x,Absolute_Index_X

/* 7F */
EM_ADC al_x,Absolute_Long_Index_X
E0_ADC al_x,Absolute_Long_Index_X
