/*

 65c816 opcodes 0x80-0x8F:
    80: BRA r       2,2
    81: STA (d,x)   2,6
    82: BRL rl      3,3
    83: STA d,s     2,4
    84: STY d       2,3
    85: STA d       2,3
    86: STX d       2,3
    87: STA [d]     2,6
    88: DEY i       1,2
    89: BIT #       2,2
    8A: TXA i       1,2
    8B: PHB s       1,3
    8C: STY a       3,4
    8D: STA a       3,4
    8E: STX a       3,4
    8F: STA al      4,5
*/

/* 80 */

ALIGNC
ALL_BRA:
    movsbl 1(_NativePC),%eax
    addl $2,_NativePC
    addl %eax,_NativePC
    jmp CPU_RETURN

/* 81 */
EM_STA Od_xO,Direct_Indexed_Indirect
E0_STA Od_xO,Direct_Indexed_Indirect

/* 82 */

ALIGNC
ALL_BRL:                // Branch always long (-32768 to 32767)
    movb 1(_NativePC),%al
    GET_PC %ebx
    movb 2(_NativePC),%ah
    addl $3,%ebx
    addl %ebx,%eax
    xorl %ebx,%ebx
    movzwl %ax,_NativePC
    movb _PB,%bl
    addb %ah,%ah
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,_PBOffset
    jmp CPU_RETURN

/* 83 */
EM_STA d_s,Stack_Relative
E0_STA d_s,Stack_Relative

/* 84 */
EX_STY d,Direct
E0_STY d,Direct

/* 85 */
EM_STA d,Direct
E0_STA d,Direct

/* 86 */
EX_STX d,Direct
E0_STX d,Direct

/* 87 */
EM_STA IdI,Direct_Indirect_Long
E0_STA IdI,Direct_Indirect_Long

/* 88 */

ALIGNC
EX_DEY:
    incl _NativePC
    decb R_Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_DEY:
    incl _NativePC
    decw R_Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 89 */    // Differs from norm, only sets Z flag

ALIGNC
EM_BIT_i:
    movb 1(_NativePC),%al
    addl $2,_NativePC
    testb R_A,%al
    STORE_FLAGS (SNES_FLAG_Z)
    jmp CPU_RETURN
ALIGNC
E0_BIT_i:
    movb 1(_NativePC),%al
    movb 2(_NativePC),%ah
    addl $3,_NativePC
    testw R_A,%ax
    STORE_FLAGS (SNES_FLAG_Z)
    jmp CPU_RETURN

/* 8A */

ALIGNC
EM_TXA:
    incl _NativePC
    movb R_X,%al
    movb %al,R_A
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_TXA:
    incl _NativePC
    movl R_X,%eax
    movl %eax,R_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 8B */

ALIGNC
E0_PHB:
    incl _NativePC
    movb R_DB,%al
	E0_PUSH_B
    jmp CPU_RETURN

ALIGNC
E1_PHB:
    incl _NativePC
    movb R_DB,%al
	E1_PUSH_B
    jmp CPU_RETURN

/* 8C */
EX_STY a,Absolute
E0_STY a,Absolute

/* 8D */
EM_STA a,Absolute
E0_STA a,Absolute

/* 8E */
EX_STX a,Absolute
E0_STX a,Absolute

/* 8F */
EM_STA al,Absolute_Long
E0_STA al,Absolute_Long
