/*

 65c816 opcodes 0x90-0x9F:
    90: BCC r       2,2
    91: STA (d),y   2,6
    92: STA (d)     2,5
    93: STA (d,s),y 2,7
    94: STY d,x     2,4
    95: STA d,x     2,4
    96: STX d,x     2,4
    97: STA [d],y   2,6
    98: TYA i       1,2
    99: STA a,y     3,5
    9A: TXS i       1,2
    9B: TXY i       1,2
    9C: STZ a       3,4
    9D: STA a,x     3,5
    9E: STZ a,x     3,5
    9F: STA al,x    4,5
*/

/* 90 */
BFC BCC,SNES_FLAG_C

/* 91 */
EM_STA OdO_y,Direct_Indirect_Indexed
E0_STA OdO_y,Direct_Indirect_Indexed

/* 92 */
EM_STA OdO,Direct_Indirect
E0_STA OdO,Direct_Indirect

/* 93 */
EM_STA Od_sO_y,Stack_Relative_Indirect_Indexed
E0_STA Od_sO_y,Stack_Relative_Indirect_Indexed

/* 94 */
EX_STY d_x,Direct_Index_X
E0_STY d_x,Direct_Index_X

/* 95 */
EM_STA d_x,Direct_Index_X
E0_STA d_x,Direct_Index_X

/* 96 */
EX_STX d_y,Direct_Index_Y
E0_STX d_y,Direct_Index_Y

/* 97 */
EM_STA IdI_y,Direct_Indirect_Indexed_Long
E0_STA IdI_y,Direct_Indirect_Indexed_Long

/* 98 */

ALIGNC
EM_TYA:
    incl _NativePC
    movb R_Y,%al
    movb %al,R_A
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_TYA:
    incl _NativePC
    movl R_Y,%eax
    movl %eax,R_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 99 */
EM_STA a_y,Absolute_Index_Y
E0_STA a_y,Absolute_Index_Y

/* 9A */

ALIGNC
E0_TXS:
    incl _NativePC
    movl R_X,%eax
    movl %eax,R_S
    jmp CPU_RETURN
ALIGNC
E1_TXS:
    incl _NativePC
    movb R_X,%al
    movb %al,R_S
    jmp CPU_RETURN

/* 9B */

ALIGNC
EX_TXY:
    incl _NativePC
    movb R_X,%al
    movb %al,R_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_TXY:
    incl _NativePC
    movl R_X,%eax
    movl %eax,R_Y
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 9C */
EM_STZ a,Absolute
E0_STZ a,Absolute

/* 9D */
EM_STA a_x,Absolute_Index_X
E0_STA a_x,Absolute_Index_X

/* 9E */
EM_STZ a_x,Absolute_Index_X
E0_STZ a_x,Absolute_Index_X

/* 9F */
EM_STA al_x,Absolute_Long_Index_X
E0_STA al_x,Absolute_Long_Index_X
