/*

 65c816 opcodes 0xC0-0xCF:
    C0: CPY #       2,2
    C1: CMP (d,x)   2,6
    C2: REP #       2,3
    C3: CMP d,s     2,4
    C4: CPY d       2,3
    C5: CMP d       2,3
    C6: DEC d       2,5
    C7: CMP [d]     2,6
    C8: INY i       1,2
    C9: CMP #       2,2
    CA: DEX i       1,2
    CB: WAI i       1,3
    CC: CPY a       3,4
    CD: CMP a       3,4
    CE: DEC a       3,6
    CF: CMP al      4,5
*/

/* C0 */
EX_CPY i,Immediate
E0_CPY i,Immediate

/* C1 */
EM_CMP Od_xO,Direct_Indexed_Indirect
E0_CMP Od_xO,Direct_Indexed_Indirect

/* C2 */

ALIGNC
E0_REP:
    E0_SETUPFLAGS
    movb 1(_NativePC),%ah
    xorb $0xFF,%ah
    andb %ah,%al
    E0_RESTOREFLAGS

    addl $2,_NativePC

    JUMP_FLAG SNES_FLAG_I,0f
    movb IRQ_pin,%al
    testb %al,%al
    jz  0f
    SAVE_PC %ebx
    addl $60,_Cycles    // IRQ processing: 2 IO + 6 bank0
    call E0_IRQ
    LOAD_PC
0:
    SET_TABLE_MX

ALIGNC
E1_REP:
    E1_SETUPFLAGS
    movb 1(_NativePC),%ah
    xorb $0xFF,%ah
    andb %ah,%al
    orb $0x30,%al
    E1_RESTOREFLAGS

    addl $2,_NativePC

    JUMP_FLAG SNES_FLAG_I,CPU_RETURN
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    SAVE_PC %ebx
    addl $52,_Cycles    // IRQ processing: 2 IO + 5 bank0
    call E1_IRQ
    LOAD_PC
    jmp CPU_RETURN

/* C3 */
EM_CMP d_s,Stack_Relative
E0_CMP d_s,Stack_Relative

/* C4 */
EX_CPY d,Direct
E0_CPY d,Direct

/* C5 */
EM_CMP d,Direct
E0_CMP d,Direct

/* C6 */
EM_DEC d,Direct
E0_DEC d,Direct

/* C7 */
EM_CMP IdI,Direct_Indirect_Long
E0_CMP IdI,Direct_Indirect_Long

/* C8 */

ALIGNC
EX_INY:
    incl _NativePC
    incb R_Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_INY:
    incl _NativePC
    incw R_Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* C9 */
EM_CMP i,Immediate
E0_CMP i,Immediate

/* CA */

ALIGNC
EX_DEX:
    incl _NativePC
    decb R_X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E0_DEX:
    incl _NativePC
    decw R_X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* CB */

ALIGNC
ALL_WAI:            // Wait for interrupt
    movb IRQ_pin,%al
    testb %al,%al
    jnz 0f
    movl EventTrip,%eax
    movb $-1,In_WAI
    cmpl _Cycles,%eax
    js  CPU_RETURN
    movl %eax,_Cycles
    jmp CPU_RETURN
ALIGNC
0:  incl _NativePC
    jmp CPU_RETURN

/* CC */
EX_CPY a,Absolute
E0_CPY a,Absolute

/* CD */
EM_CMP a,Absolute
E0_CMP a,Absolute

/* CE */
EM_DEC a,Absolute
E0_DEC a,Absolute

/* CF */
EM_CMP al,Absolute_Long
E0_CMP al,Absolute_Long
