/*

 65c816 opcodes 0xF0-0xFF:
    F0: BEQ r       2,2
    F1: SBC (d),y   2,5
    F2: SBC (d)     2,5
    F3: SBC (d,s),y 2,7
    F4: PEA s       3,5
    F5: SBC d,x     2,4
    F6: INC d,x     2,6
    F7: SBC [d],y   2,6
    F8: SED i       1,2
    F9: SBC a,y     3,4
    FA: PLX s       1,4
    FB: XCE i       1,2
    FC: JSR (a,x)   3,6
    FD: SBC a,x     3,4
    FE: INC a,x     3,7
    FF: SBC al,x    4,5
*/

/* F0 */
BFS BEQ,SNES_FLAG_Z

/* F1 */
EM_SBC OdO_y,Direct_Indirect_Indexed
E0_SBC OdO_y,Direct_Indirect_Indexed

/* F2 */
EM_SBC OdO,Direct_Indirect
E0_SBC OdO,Direct_Indirect

/* F3 */
EM_SBC Od_sO_y,Stack_Relative_Indirect_Indexed
E0_SBC Od_sO_y,Stack_Relative_Indirect_Indexed

/* F4 */

ALIGNC
E0_PEA:
    movb 1(_NativePC),%al
    movb 2(_NativePC),%ah
    addl $3,_NativePC
    E0_PUSH_W
    jmp CPU_RETURN

ALIGNC
E1_PEA:
    movb 1(_NativePC),%al
    movb 2(_NativePC),%ah
    addl $3,_NativePC
    E1_PUSH_W
    jmp CPU_RETURN

/* F5 */
EM_SBC d_x,Direct_Index_X
E0_SBC d_x,Direct_Index_X

/* F6 */
EM_INC d_x,Direct_Index_X
E0_INC d_x,Direct_Index_X

/* F7 */
EM_SBC IdI_y,Direct_Indirect_Indexed_Long
E0_SBC IdI_y,Direct_Indirect_Indexed_Long

/* F8 */

ALIGNC
ALL_SED:
    incl _NativePC
	SET_FLAG SNES_FLAG_D
    jmp CPU_RETURN

/* F9 */
EM_SBC a_y,Absolute_Index_Y
E0_SBC a_y,Absolute_Index_Y

/* FA */

ALIGNC
E0_PLX:
    incl _NativePC
    E0_PULL_W
    movl %eax,R_X
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
EX_PLX:
    incl _NativePC
    E0_PULL_B
    movb %al,R_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGNC
E1_PLX:
    incl _NativePC
    E1_PULL_B
    movb %al,R_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* FB */

ALIGNC
E0_XCE:
    incl _NativePC

    JUMP_NOT_FLAG SNES_FLAG_C,CPU_RETURN
    movb %ah,_X+1
    movb %ah,_Y+1
    CLR_FLAG(SNES_FLAG_C)
    SET_FLAG(SNES_FLAG_E+SNES_FLAG_B1)
    movb $0x01,_S+1         // Make High S=0x01
    movl $OpTableE1,OpTable // Set current opcode emulation table
    jmp CPU_RETURN

ALIGNC
E1_XCE:
    incl _NativePC

    JUMP_FLAG SNES_FLAG_C,CPU_RETURN
    SET_FLAG(SNES_FLAG_C+SNES_FLAG_MX)
    CLR_FLAG(SNES_FLAG_E)
    movl $OpTableMX,OpTable // Set current opcode emulation table
    jmp CPU_RETURN

/* FC */

ALIGNC
E0_JSR_Oa_xO:
    GET_PC %eax
    addl $2,%eax        // last instruction byte PC in ax
    E0_PUSH_W           // Address of last byte not next instruction (huh!)
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    movl %eax,_NativePC
    addb %ah,%ah
    movb R_PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

ALIGNC
E1_JSR_Oa_xO:
    GET_PC %eax
    addl $2,%eax        // last instruction byte PC in ax
    E1_PUSH_W           // Address of last byte not next instruction (huh!)
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    movl %eax,_NativePC
    addb %ah,%ah
    movb R_PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    addl %eax,_NativePC
    movl %eax,R_PBOffset
    jmp CPU_RETURN

/* FD */
EM_SBC a_x,Absolute_Index_X
E0_SBC a_x,Absolute_Index_X

/* FE */
EM_INC a_x,Absolute_Index_X
E0_INC a_x,Absolute_Index_X

/* FF */
EM_SBC al_x,Absolute_Long_Index_X
E0_SBC al_x,Absolute_Long_Index_X
