//#define Tile_Cache_Uses_Dirty_Flags
#define Set_Based_Tile_Cache
//#define Profile_VRAM_Writes
//#define Profile_Recache_Sets
//#define Check_Within_Tile_Set
/*

 PPU.S - Contains the hardware mapping functions

*/

#include "misc.i"
#include "PPU.i"
#include "regs.i"
#include "key.i"
#include "DMA.i"
#include "spriteL.i"
#include "screen.i"

EXPORT_C PPU_start

.data
ALIGND
.globl Read_Map_20_5F
Read_Map_20_5F:
    // 2000-20FF: Unmapped
    DUPLICATE long,0x100,UNSUPPORTED_READ
.globl Read_Map_21
Read_Map_21:
    DUPLICATE long,0x16,UNSUPPORTED_READ
    .long   SNES_R2116  // VMADDL
    .long   SNES_R2117  // VMADDH
    DUPLICATE long,0x1C,UNSUPPORTED_READ
    .long   SNES_R2134  // MPYL
    .long   SNES_R2135  // MPYM
    .long   SNES_R2136  // MPYH
    .long   SNES_R2137  // SLHV
    .long   SNES_R2138  // OAMDATAREAD
    .long   SNES_R2139_NORM // VMDATALREAD
    .long   SNES_R213A_NORM // VMDATAHREAD
    .long   SNES_R213B  // CGDATAREAD     // v0.14
    .long   SNES_R213C  // OPHCT          // v0.14
    .long   SNES_R213D  // OPVCT
    .long   SNES_R213E  // STAT77   // Not supported yet (properly..)
    .long   SNES_R213F  // STAT78
    DUPLICATE long,0x40,UNSUPPORTED_READ    // APUI00-APUI03??
    .long   SNES_R2180  // WMDATA   // 2180 WMDATA - read/write to Work RAM
    .long   SNES_R2181  // WMADDL   // v0.14
    .long   SNES_R2182  // WMADDM   // v0.14
    .long   SNES_R2183  // WMADDH   // v0.14
    DUPLICATE long,0x3E,UNSUPPORTED_READ
    .long   SNES_R21C2  // Unknown?
    .long   SNES_R21C3  // Unknown?
    DUPLICATE long,0x3C,UNSUPPORTED_READ
    // 2200-3FFF: Unmapped
    DUPLICATE long,0x1E00,UNSUPPORTED_READ
.globl Read_Map_40
Read_Map_40:
    DUPLICATE long,0x16,UNSUPPORTED_READ
    .long   SNES_R4016  // JOYC1
    .long   SNES_R4017  // JOYC2
    DUPLICATE long,0xE8,UNSUPPORTED_READ
    // 4100-41FF: Unmapped
    DUPLICATE long,0x100,UNSUPPORTED_READ
.globl Read_Map_42
Read_Map_42:
    .long   SNES_R4200  // NMITIMEN
    DUPLICATE long,0x01,UNSUPPORTED_READ
    .long   SNES_R4202  // WRMPYA
    .long   SNES_R4203  // WRMPYB
    DUPLICATE long,0x07,UNSUPPORTED_READ
    .long   SNES_R420B  // MDMAEN
    .long   SNES_R420C  // HDMAEN
    DUPLICATE long,3,UNSUPPORTED_READ
    .long   SNES_R4210  // RDNMI
    .long   SNES_R4211  // TIMEUP
    .long   SNES_R4212  // HVBJOY
    .long   SNES_R4213  // RDIO     // Not yet supported... probably never
    .long   SNES_R4214  // RDDIVL
    .long   SNES_R4215  // RDDIVH
    .long   SNES_R4216  // RDMPYL
    .long   SNES_R4217  // RDMPYH
    .long   SNES_R4218  // JOY1L
    .long   SNES_R4219  // JOY1H
    .long   SNES_R421A  // JOY2L
    .long   SNES_R421B  // JOY2H
    .long   SNES_R421C  // JOY3L    // Not yet supported
    .long   SNES_R421D  // JOY3H
    .long   SNES_R421E  // JOY4L    // Not yet supported
    .long   SNES_R421F  // JOY4H
    DUPLICATE long,0xE0,UNSUPPORTED_READ

.globl Read_Map_43
Read_Map_43:
    MAP_READ_DMA_LIST 0
    MAP_READ_DMA_LIST 1
    MAP_READ_DMA_LIST 2
    MAP_READ_DMA_LIST 3
    MAP_READ_DMA_LIST 4
    MAP_READ_DMA_LIST 5
    MAP_READ_DMA_LIST 6
    MAP_READ_DMA_LIST 7
    DUPLICATE long,0x80,UNSUPPORTED_READ
    // 4300-5FFF: Unmapped
    DUPLICATE long,0x1D00,UNSUPPORTED_READ

ALIGND
.globl Write_Map_20_5F
Write_Map_20_5F:
    // 2000-20FF: Unmapped
    DUPLICATE long,0x100,UNSUPPORTED_WRITE
.globl Write_Map_21
Write_Map_21:
    .long   SNES_W2100  // INIDISP
    .long   SNES_W2101  // OBSEL
    .long   SNES_W2102  // OAMADDL
    .long   SNES_W2103  // OAMADDH
    .long   SNES_W2104  // OAMDATA
    .long   SNES_W2105  // BGMODE
    .long   SNES_W2106  // MOSAIC
    .long   SNES_W2107  // BG1SC
    .long   SNES_W2108  // BG2SC
    .long   SNES_W2109  // BG3SC
    .long   SNES_W210A  // BG4SC
    .long   SNES_W210B  // BG12NBA
    .long   SNES_W210C  // BG34NBA
    .long   SNES_W210D  // BG1HOFS
    .long   SNES_W210E  // BG1VOFS
    .long   SNES_W210F  // BG2HOFS
    .long   SNES_W2110  // BG2VOFS
    .long   SNES_W2111  // BG3HOFS
    .long   SNES_W2112  // BG3VOFS
    .long   SNES_W2113  // BG4HOFS
    .long   SNES_W2114  // BG4VOFS
    .long   SNES_W2115  // VMAIN
    .long   SNES_W2116  // VMADDL
    .long   SNES_W2117  // VMADDH
    .long   SNES_W2118_NORM // VMDATAL
    .long   SNES_W2119_NORM // VMDATAH
    .long   SNES_W211A  // M7SEL
    .long   SNES_W211B  // M7A
    .long   SNES_W211C  // M7B
    .long   SNES_W211D  // M7C
    .long   SNES_W211E  // M7D
    .long   SNES_W211F  // M7X
    .long   SNES_W2120  // M7Y
    .long   SNES_W2121  // CGADD
    .long   SNES_W2122  // CGDATA
    .long   SNES_W2123  // W12SEL
    .long   SNES_W2124  // W34SEL
    .long   SNES_W2125  // WOBJSEL
    .long   SNES_W2126  // WH0
    .long   SNES_W2127  // WH1
    .long   SNES_W2128  // WH2
    .long   SNES_W2129  // WH3
    .long   SNES_W212A  // WBGLOG
    .long   SNES_W212B  // WOBJLOG
    .long   SNES_W212C  // TM
    .long   SNES_W212D  // TS
    .long   SNES_W212E  // TMW
    .long   SNES_W212F  // TSW
    .long   SNES_W2130  // CGWSEL
    .long   SNES_W2131  // CGADSUB
    .long   SNES_W2132  // COLDATA
    .long   SNES_W2133  // SETINI
    DUPLICATE long,0x0C,UNSUPPORTED_WRITE
    DUPLICATE long,0x40,UNSUPPORTED_WRITE   // APUI00-APUI03??
    .long   SNES_W2180  // WMDATA   // 2180 WMDATA - read/write to Work RAM
    .long   SNES_W2181  // WMADDL   // 2181-3 WMAddress
    .long   SNES_W2182  // WMADDM
    .long   SNES_W2183  // WMADDH
    DUPLICATE long,0x7C,UNSUPPORTED_WRITE
    // 2200-3FFF: Unmapped
    DUPLICATE long,0x1E00,UNSUPPORTED_WRITE
.globl Write_Map_40
Write_Map_40:
    DUPLICATE long,0x16,UNSUPPORTED_WRITE
    .long   SNES_W4016  // JOYC1
    .long   SNES_W4017  // JOYC2
    DUPLICATE long,0xE8,UNSUPPORTED_WRITE
    // 4100-41FF: Unmapped
    DUPLICATE long,0x100,UNSUPPORTED_WRITE
.globl Write_Map_42
Write_Map_42:
    .long   SNES_W4200  // NMITIMEN
    .long   SNES_W4201  // WRIO
    .long   SNES_W4202  // WRMPYA
    .long   SNES_W4203  // WRMPYB
    .long   SNES_W4204  // WRDIVL
    .long   SNES_W4205  // WRDIVH
    .long   SNES_W4206  // WRDIVB
    .long   SNES_W4207  // HTIMEL
    .long   SNES_W4208  // HTIMEH
    .long   SNES_W4209  // VTIMEL
    .long   SNES_W420A  // VTIMEH
    .long   SNES_W420B  // MDMAEN
    .long   SNES_W420C  // HDMAEN
    .long   SNES_W420D  // MEMSEL
    DUPLICATE long,2,UNSUPPORTED_WRITE
    .long   SNES_W4210  // RDNMI
    .long   SNES_W4211  // TIMEUP
    .long   IGNORE_WRITE    // HVBJOY
    .long   IGNORE_WRITE    // RDIO
    .long   IGNORE_WRITE    // RDDIVL
    .long   IGNORE_WRITE    // RDDIVH
    .long   IGNORE_WRITE    // RDMPYL
    .long   IGNORE_WRITE    // RDMPYH
    .long   IGNORE_WRITE    // JOY1L
    .long   IGNORE_WRITE    // JOY1H
    .long   IGNORE_WRITE    // JOY2L
    .long   IGNORE_WRITE    // JOY2H
    .long   IGNORE_WRITE    // JOY3L
    .long   IGNORE_WRITE    // JOY3H
    .long   IGNORE_WRITE    // JOY4L
    .long   IGNORE_WRITE    // JOY4H
    DUPLICATE long,0xE0,UNSUPPORTED_WRITE

.globl Write_Map_43
Write_Map_43:
    MAP_WRITE_DMA_LIST 0
    MAP_WRITE_DMA_LIST 1
    MAP_WRITE_DMA_LIST 2
    MAP_WRITE_DMA_LIST 3
    MAP_WRITE_DMA_LIST 4
    MAP_WRITE_DMA_LIST 5
    MAP_WRITE_DMA_LIST 6
    MAP_WRITE_DMA_LIST 7
    DUPLICATE long,0x80,UNSUPPORTED_WRITE
    // 4300-5FFF: Unmapped
    DUPLICATE long,0x1D00,UNSUPPORTED_WRITE

ALIGND
// BG12NBA/BG34NBA to tileset-in-cache address tables
BGNBA_Table_2:
.long 0<<15,1<<15,2<<15,3<<15,4<<15,5<<15,6<<15,7<<15
BGNBA_Table_4:
.long 0<<14,1<<14,2<<14,3<<14,4<<14,5<<14,6<<14,7<<14
BGNBA_Table_8:
.long 0<<13,1<<13,2<<13,3<<13,4<<13,5<<13,6<<13,7<<13
// BGMODE layer depth tables
// Standard
//  1 = 2-bit   2 = 4-bit   3=8-bit
// Offset Change
//  5 = 2-bit   6 = 4-bit   7=8-bit
// Special
//  4 = mode-7  9 = 2-bit mode-0        0 = no more layers
BGMODE_Depth_Table:
.byte 9,9,9,9
.byte 2,2,1,0
.byte 6,6,0,0
.byte 3,2,0,0
.byte 7,5,0,0
.byte 2,1,0,0
.byte 6,0,0,0
.byte 4,0,0,0

ALIGND
LineRenderSmall:
.long 0,RENDER_8x8_C2,RENDER_8x8_C4,RENDER_8x8_C8
.long RENDER_MODE_7,RENDER_8x8_C2,RENDER_8x8_C4_Offset,RENDER_8x8_C8
.long 0,RENDER_M0_8x8

ALIGND
LineRenderLarge:
.long 0,RENDER_16x16_C2,RENDER_16x16_C4,RENDER_16x16_C8
.long RENDER_MODE_7,RENDER_16x16_C2,RENDER_16x16_C4,RENDER_16x16_C8
.long 0,RENDER_M0_16x16

ALIGND
LineRenderEvenSmall:
.long 0,RENDER_16x8_Even_C2,RENDER_16x8_Even_C4,0
.long RENDER_MODE_7,RENDER_16x8_Even_C2,RENDER_16x8_Even_C4,0

ALIGND
LineRenderEvenLarge:
.long 0,RENDER_16x16_Even_C2,RENDER_16x16_Even_C4,0
.long RENDER_MODE_7,RENDER_16x16_Even_C2,RENDER_16x16_Even_C4,0

Depth_NBA_Table:
.long 0,BGNBA_Table_2,BGNBA_Table_4,BGNBA_Table_8

.bss
ALIGND
.globl _WRAM,_VRAM,_VRAM_DI,_SRAM,_SPCRAM,_Blank
_WRAM:          skipk 128   // Buffer for Work RAM
_VRAM:          skipk 64    // Buffer for Video RAM
_VRAM_DI:       skipk 64    // Buffer for Video RAM (deinterleaved)
_SRAM:          skipk 64    // Buffer for Save RAM
_SPCRAM:        skipk 64    // Buffer for SPC RAM/ROM
_Blank:         skipk 64    // Blank ROM buffer
_PortRAM:       skipk 24    // Ports 0x2000-0x5FFF

ALIGND
VRAMAddress:    skipl   // VRAM address in PPU
SCINC:          skipl   // Used in updating VRAM address
PaletteData:    skipw
.balign 4
.globl Tile_Recache_Set_Begin,Tile_Recache_Set_End
Tile_Recache_Set_Begin: skipl
Tile_Recache_Set_End:   skipl

.globl Mosaic_Size,MOSAIC
Mosaic_Size:skipl   // 000xxxxx  xxxxx=2-10 pixel size
.globl _INIDISP
_INIDISP:   skipb   // x000bbbb x=screen on/off,bbbb=Brightness
.globl _BGMODE
_BGMODE:    skipb   // abcdefff a-d=tile size bg4-1 (8/16),e=priority bg3,fff=mode
MOSAIC:     skipb   // xxxxabcd  xxxx=0-F pixel size,a-d = affect BG4-1

.globl BG1SC,BG2SC,BG3SC,BG4SC
.globl _BGSC1,_BGSC2,_BGSC3,_BGSC4
.globl _BG1SC,_BG2SC,_BG3SC,_BG4SC
_BG1SC:     skipb   // xxxxxxab  xxxxxx=base address, ab=SC Size
_BG2SC:     skipb   // xxxxxxab  xxxxxx=base address, ab=SC Size
_BG3SC:     skipb   // xxxxxxab  xxxxxx=base address, ab=SC Size
_BG4SC:     skipb   // xxxxxxab  xxxxxx=base address, ab=SC Size

.globl _BG12NBA,_BG34NBA
_BG12NBA:   skipb   // aaaabbbb  aaaa=base address 2, bbbb=base address 1
_BG34NBA:   skipb   // aaaabbbb  aaaa=base address 4, bbbb=base address 3

.globl _VMAIN
_VMAIN:     skipb   // i000abcd  i=inc type,ab=full graphic,cd=SC increment
.balign 4
.globl _W12SEL,_W34SEL,_WOBJSEL
_W12SEL:    skipb   // Holds plane 1/2 window mask settings
_W34SEL:    skipb   // Holds plane 3/4 window mask settings
_WOBJSEL:   skipb   // Holds colour/object window mask settings
            skipb
.globl _WH0,_WH1,_WH2,_WH3
.globl _TM,_TS,_TMW,_TSW
.globl _WBGLOG,_WOBJLOG,_CGWSEL,_CGADSUB
.globl Win1_Count_In,Win1_Count_Out,Win2_Count_In,Win2_Count_Out
.globl Win1_Bands_In,Win1_Bands_Out,Win2_Bands_In,Win2_Bands_Out
Win1_Count_In:  skipb
_WH0:   skipb   // Holds window 1 left position
_TM:    skipb   // 000odcba  o=OBJ enable,a-d=BG1-4 enable
_WBGLOG:    skipb   // BG Window mask logic
Win1_Count_Out: skipb
_WH1:   skipb   // Holds window 1 right position
_TMW:   skipb
_WOBJLOG:   skipb   // OBJ/Colour Window mask logic
Win2_Count_In:  skipb
_WH2:   skipb   // Holds window 2 left position
_TS:    skipb   // 000odcba  o=OBJ enable,a-d=BG1-4 enable
_CGWSEL:    skipb
Win2_Count_Out: skipb
_WH3:   skipb   // Holds window 2 right position
_TSW:   skipb
_CGADSUB:   skipb
Win1_Bands_In:  skipb 8
Win1_Bands_Out: skipb 8
Win2_Bands_In:  skipb 8
Win2_Bands_Out: skipb 8
.balign 4
.globl _COLDATA
_COLDATA:   skipl   // Actual data from COLDATA
CGAddress:  skipl   // Palette position for writes to CGRAM
// First and last changed colors in run to be reprocessed in color conversion
// Not yet used
FirstChangedColor:  skipl
LastChangedColor:   skipl
CGOdd:      skipb   // Holds whether writing to first or second byte
CGReadOdd:  skipb   // Whether reading lo or high byte

.balign 4
WMADDL:     skipb   // Work RAM Address Lo Byte
WMADDM:     skipb   // Work RAM Address Mid Byte
WMADDH:     skipb   // Work RAM Address Hi Byte - Just bit 0 used!
            skipb
JOYC1:      skipb   // This holds the controller read control byte
Controller1_Pos:    skipb   // Shift count for controller 1 read
Controller23_Pos:   skipb   // Shift count for controller 2/3 read
Controller45_Pos:   skipb   // Shift count for controller 4/5 read

.globl MEMSEL
MEMSEL:     skipl   // FastROM switch
Latched_H:  skipl   // These two are latched values!
Latched_V:  skipl
OPHCT:      skipb   // Whether reading lo or high byte
OPVCT:      skipb   // Whether reading lo or high byte
.globl RDNMI
RDNMI:      skipb   // x000vvvv  x=disable/enable NMI,vvvv=version?
.globl TIMEUP
TIMEUP:     skipb   // IRQ signalled flag
.globl NMITIMEN
NMITIMEN:   skipb   // a0yx000b  a=NMI on/off,y=vert count,x=horiz count,b=joy read
.globl HVBJOY
HVBJOY:     skipb
.globl _SETINI
_SETINI:    skipb
.globl STAT78
STAT78:     skipb   // Enable support for field register

RDDIVL:     skipb   // Quotient of divide
RDDIVH:     skipb
RDMPYL:     skipb   // Multiplication or remainder
RDMPYH:     skipb
WRMPYA:     skipb   // Multiplicand A
WRMPYB:     skipb   // Multiplicand B
WRDIVL:     skipb   // Dividend C
WRDIVH:     skipb

ALIGND
JOY1L:      skipb   // These are updated per VBL rather than per read!
JOY1H:      skipb
            skipw
JOY2L:      skipb
JOY2H:      skipb
            skipw
JOY3L:      skipb   // These are not updated yet
JOY3H:      skipb
            skipw
JOY4L:      skipb
JOY4H:      skipb
            skipw

.globl Current_Line_Timing,Current_Line_Render,Current_Line_Mosaic
Current_Line_Timing:skipl
Current_Line_Render:skipl
Current_Line_Mosaic:skipl

.globl Redo_BGs
Redo_BGs:   skipb
.globl Redo_OAM
Redo_OAM:   skipb

.globl SCR_TM
SCR_TM:     skipb   // TM taken from here (TM&TM_MASK=SCR_TM)
.globl SCR_TS
SCR_TS:     skipb   // TS taken from here (TS&TM_MASK=SCR_TS)
.globl Layering_Mode
Layering_Mode:  skipb

.globl TableBG1,TableBG2,TableBG3,TableBG4
.globl FirstPixelBG1,FirstTileBG1,TileCount1BG1,TileCount2BG1
.globl MapAddressBG1,LMapAddressBG1,RMapAddressBG1,SetAddressBG1
.globl VLMapAddressBG1,VRMapAddressBG1,Redo_BG1
.globl _BG1HOFS,_BG1VOFS,HScroll_1,VScroll_1,MosaicBG1,NBABG1,DepthBG1
.globl TLMapAddressBG1,TRMapAddressBG1,BLMapAddressBG1,BRMapAddressBG1
.globl FirstPixelBG2,FirstTileBG2,TileCount1BG2,TileCount2BG2
.globl MapAddressBG2,LMapAddressBG2,RMapAddressBG2,SetAddressBG2
.globl VLMapAddressBG2,VRMapAddressBG2,Redo_BG2
.globl _BG2HOFS,_BG2VOFS,HScroll_2,VScroll_2,MosaicBG2,NBABG2,DepthBG2
.globl TLMapAddressBG2,TRMapAddressBG2,BLMapAddressBG2,BRMapAddressBG2
.globl FirstPixelBG3,FirstTileBG3,TileCount1BG3,TileCount2BG3
.globl MapAddressBG3,LMapAddressBG3,RMapAddressBG3,SetAddressBG3
.globl VLMapAddressBG3,VRMapAddressBG3,Redo_BG3
.globl _BG3HOFS,_BG3VOFS,HScroll_3,VScroll_3,MosaicBG3,NBABG3,DepthBG3
.globl TLMapAddressBG3,TRMapAddressBG3,BLMapAddressBG3,BRMapAddressBG3
.globl FirstPixelBG4,FirstTileBG4,TileCount1BG4,TileCount2BG4
.globl MapAddressBG4,LMapAddressBG4,RMapAddressBG4,SetAddressBG4
.globl VLMapAddressBG4,VRMapAddressBG4,Redo_BG4
.globl _BG4HOFS,_BG4VOFS,HScroll_4,VScroll_4,MosaicBG4,NBABG4,DepthBG4
.globl TLMapAddressBG4,TRMapAddressBG4,BLMapAddressBG4,BRMapAddressBG4

// MapAddress - base address of tilemap
// LMapAddress - address of tilemap for left 32 tiles
// RMapAddress - address of tilemap for right 32 tiles
// L/R will be same if tilemap only 32 tiles wide!
// VL/VR are vertically adjusted for current scanline
// SetAddress - address of tileset in cache
// FirstOffset - first pixel on visible screen in leftmost tile
// TileCount1 - count of visible tiles in left 32 tiles of tilemap
// TileCount2 - count of visible tiles in right 32 tiles of tilemap
// Redo - procedure used to recalculate first offset and tile counts

ALIGND
TableBG1:
TileCount1BG1:  skipb
TileCount2BG1:  skipb
_BGSC1:
BG1SC:          skipb   // SC size
DepthBG1:       skipb
Redo_BG1:       skipl
FirstPixelBG1:  skipl
FirstTileBG1:   skipl

VScroll_1:
_BG1VOFS:       skipl
HScroll_1:
_BG1HOFS:       skipl
VLMapAddressBG1:skipl
VRMapAddressBG1:skipl

LineRenderBG1:  skipl
SetAddressBG1:  skipl   // Address of BG1 tileset
LMapAddressBG1: skipl
RMapAddressBG1: skipl

TLMapAddressBG1:
MapAddressBG1:  skipl   // Screen address of BG1
TRMapAddressBG1:skipl
BLMapAddressBG1:skipl
BRMapAddressBG1:skipl

TileHeightBG1:  skipb
TileWidthBG1:   skipb
MosaicBG1:      skipb
NBABG1:         skipb
NBATableBG1:    skipl

ALIGND
TableBG2:
TileCount1BG2:  skipb
TileCount2BG2:  skipb
_BGSC2:
BG2SC:          skipb   // SC size
DepthBG2:       skipb
Redo_BG2:       skipl
FirstPixelBG2:  skipl
FirstTileBG2:   skipl

VScroll_2:
_BG2VOFS:       skipl
HScroll_2:
_BG2HOFS:       skipl
VLMapAddressBG2:skipl
VRMapAddressBG2:skipl

LineRenderBG2:  skipl
SetAddressBG2:  skipl   // Address of BG2 tileset
LMapAddressBG2: skipl
RMapAddressBG2: skipl

TLMapAddressBG2:
MapAddressBG2:  skipl   // Screen address of BG2
TRMapAddressBG2:skipl
BLMapAddressBG2:skipl
BRMapAddressBG2:skipl

TileHeightBG2:  skipb
TileWidthBG2:   skipb
MosaicBG2:      skipb
NBABG2:         skipb
NBATableBG2:    skipl

ALIGND
TableBG3:
TileCount1BG3:  skipb
TileCount2BG3:  skipb
_BGSC3:
BG3SC:          skipb   // SC size
DepthBG3:       skipb
Redo_BG3:       skipl
FirstPixelBG3:  skipl
FirstTileBG3:   skipl

VScroll_3:
_BG3VOFS:       skipl
HScroll_3:
_BG3HOFS:       skipl
VLMapAddressBG3:skipl
VRMapAddressBG3:skipl

LineRenderBG3:  skipl
SetAddressBG3:  skipl   // Address of BG3 tileset
LMapAddressBG3: skipl
RMapAddressBG3: skipl

TLMapAddressBG3:
MapAddressBG3:  skipl   // Screen address of BG3
TRMapAddressBG3:skipl
BLMapAddressBG3:skipl
BRMapAddressBG3:skipl

TileHeightBG3:  skipb
TileWidthBG3:   skipb
MosaicBG3:      skipb
NBABG3:         skipb   // Unused
NBATableBG3:    skipl   // Unused

ALIGND
TableBG4:
TileCount1BG4:  skipb
TileCount2BG4:  skipb
_BGSC4:
BG4SC:          skipb   // SC size
DepthBG4:       skipb
Redo_BG4:       skipl
FirstPixelBG4:  skipl
FirstTileBG4:   skipl

VScroll_4:
_BG4VOFS:       skipl
HScroll_4:
_BG4HOFS:       skipl
VLMapAddressBG4:skipl
VRMapAddressBG4:skipl

LineRenderBG4:  skipl
SetAddressBG4:  skipl   // Address of BG4 tileset
LMapAddressBG4: skipl
RMapAddressBG4: skipl

TLMapAddressBG4:
MapAddressBG4:  skipl   // Screen address of BG4
TRMapAddressBG4:skipl
BLMapAddressBG4:skipl
BRMapAddressBG4:skipl

TileHeightBG4:  skipb
TileWidthBG4:   skipb
MosaicBG4:      skipb
NBABG4:         skipb   // Unused
NBATableBG4:    skipl   // Unused

.text
ALIGNC
.globl Reset_Ports
Reset_Ports:
  pusha

  call Reset_Sprites
  call Reset_DMA
  call _Reset_APU_Skipper
  call _Reset_Mode_7

  cld
  movl $_PortRAM,%edi
  movl $0x6000 / 4,%ecx
  movl $-1,%eax     // Reset to 0xFF
  rep; stosl

  // Set eax to 0, as we're setting most everything to 0...
  xorl %eax,%eax

  movb %al,SCR_TM
  movb %al,SCR_TS

  movl $Render_Layering_Option_0,Render_Select
  movb $0,Layering_Mode

  movl $224,LastRenderLine

  movl $SCREEN_MODE_0,Render_Mode
  movl %eax,Latched_H
  movl %eax,Latched_V

  movl %eax,WMADDL

  movl %eax,VRAMAddress
  movl $1,SCINC
  movb %al,_VMAIN
  movb %al,MOSAIC
  movb %al,MosaicBG1
  movb %al,MosaicBG2
  movb %al,MosaicBG3
  movb %al,MosaicBG4
  movl %eax,Mosaic_Size

  movb $3,STAT78

  movl %eax,CGAddress
  movb %al,CGOdd
  movb %al,CGReadOdd

  movb %al,_BGSC1
  movb %al,_BGSC2
  movb %al,_BGSC3
  movb %al,_BGSC4
  movb $0x0F,Redo_BGs
  movb %al,_BGMODE
  movb %al,_BG1SC
  movb %al,_BG2SC
  movb %al,_BG3SC
  movb %al,_BG4SC
  movb %al,_BG12NBA
  movb %al,_BG34NBA
  movb %al,NBABG1
  movb %al,NBABG2
  movb %al,NBABG3
  movb %al,NBABG4

  movb %al,WRMPYA
  movb %al,WRDIVL
  movb %al,WRDIVH
  movb %al,RDDIVL
  movb %al,RDDIVH
  movb %al,RDMPYL
  movb %al,RDMPYH

  movl %eax,MEMSEL
  movb %al,HVBJOY
  movb %al,NMITIMEN
  movl %eax,HTIMEL
  movl %eax,VTIMEL

  movb %al,_WH0
  movb %al,_WH1
  movb %al,_WH2
  movb %al,_WH3
  movb %al,_WBGLOG
  movb %al,_WOBJLOG
  movb %al,_W12SEL
  movb %al,_W34SEL
  movb %al,_WOBJSEL
  movb %al,_TM
  movb %al,_TS
  movb %al,_SETINI
  movl %eax,_COLDATA
  movb %al,_CGWSEL
  movb %al,_CGADSUB

  movb %al,JOYC1
  movb $16,Controller1_Pos
  movb $16,Controller23_Pos
  movb $16,Controller45_Pos
  movl $(1<<31),JOY1L
  movl $(1<<31),JOY2L
  movl $(1<<31),JOY3L
  movl $(1<<31),JOY4L

  movb %al,_BrightnessLevel
  movb $0x80,_INIDISP
  movb %al,OPHCT
  movb %al,OPVCT
  movl $Redo_8,Redo_BG1
  movl $Redo_8,Redo_BG2
  movl $Redo_8,Redo_BG3
  movl $Redo_8,Redo_BG4
  movl %eax,_BG1HOFS
  movl %eax,_BG1VOFS
  movl %eax,_BG2HOFS
  movl %eax,_BG2VOFS
  movl %eax,_BG3HOFS
  movl %eax,_BG3VOFS
  movl %eax,_BG4HOFS
  movl %eax,_BG4VOFS
  movl %eax,OffsetChangeMap_HOffset

  movl %eax,SetAddressBG1
  movl %eax,SetAddressBG2
  movl %eax,SetAddressBG3
  movl %eax,SetAddressBG4
  movl $BGNBA_Table_2,NBATableBG1
  movl $BGNBA_Table_2,NBATableBG2
  movl $BGNBA_Table_2,NBATableBG3
  movl $BGNBA_Table_2,NBATableBG4
  movl $RENDER_M0_8x8,LineRenderBG1
  movl $RENDER_M0_8x8,LineRenderBG2
  movl $RENDER_M0_8x8,LineRenderBG3
  movl $RENDER_M0_8x8,LineRenderBG4
  movb $1,TileHeightBG1
  movb $1,TileHeightBG2
  movb $1,TileHeightBG3
  movb $1,TileHeightBG4
  movb $1,TileWidthBG1
  movb $1,TileWidthBG2
  movb $1,TileWidthBG3
  movb $1,TileWidthBG4
  movb $1,DepthBG1
  movb $1,DepthBG2
  movb $1,DepthBG3
  movb $1,DepthBG4
  movb $2,RDNMI

  movl $_VRAM,%eax
  movl %eax,TLMapAddressBG1 //MapAddressBG1
  movl %eax,TLMapAddressBG2 //MapAddressBG2
  movl %eax,TLMapAddressBG3 //MapAddressBG3
  movl %eax,TLMapAddressBG4 //MapAddressBG4
  movl %eax,TRMapAddressBG1
  movl %eax,TRMapAddressBG2
  movl %eax,TRMapAddressBG3
  movl %eax,TRMapAddressBG4
  movl %eax,BLMapAddressBG1
  movl %eax,BLMapAddressBG2
  movl %eax,BLMapAddressBG3
  movl %eax,BLMapAddressBG4
  movl %eax,BRMapAddressBG1
  movl %eax,BRMapAddressBG2
  movl %eax,BRMapAddressBG3
  movl %eax,BRMapAddressBG4
/*movl %eax,LMapAddressBG1
  movl %eax,LMapAddressBG2
  movl %eax,LMapAddressBG3
  movl %eax,LMapAddressBG4
  movl %eax,RMapAddressBG1
  movl %eax,RMapAddressBG2
  movl %eax,RMapAddressBG3
  movl %eax,RMapAddressBG4*/
  movl %eax,OffsetChangeMap_VOffset

  Set_21_Read 0x39,SNES_R2139_NORM
  Set_21_Read 0x3A,SNES_R213A_NORM
  Set_21_Write 0x18,SNES_W2118_NORM
  Set_21_Write 0x19,SNES_W2119_NORM

  popa
  ret

// JOYPAD UPDATE FUNCTION.. now called during VBL to accomodate JOYC1 & JOYC2
ALIGNC
.globl UPDATE_CONTROLLERS
UPDATE_CONTROLLERS:
    pusha
    call UPDATE_JOYSTICKS

    testb $1,NMITIMEN
    jz  0f
    movb $0,Controller1_Pos
    movb $0,Controller23_Pos
    movb $0,Controller45_Pos
0:
// UPDATE CONTROLLER 1

/*  cmpb $1,_JOYSTICK_ENABLED
    jne controller_1_no_joystick

    call _poll_joystick

    // Below needs to be rewritten to support Allegro 3.1
    movb $0,%al
    cmpl $0,_joy_b4     // Is A pressed?
    je 0f
    orb $0x80,%al
0:  cmpl $0,_joy_b2     // Is X pressed?
    je 0f
    orb $0x40,%al
0:  cmpl $0,_joy_b5     // Is L pressed?
    je 0f
    orb $0x20,%al
0:  cmpl $0,_joy_b6     // Is R pressed?
    je 0f
    orb $0x10,%al
0:  movb %al,JOY1L

    movb $0,%al
    cmpl $0,_joy_b3     // Is B pressed?
    je 0f
    orb $0x80,%al
0:  cmpl $0,_joy_b1     // Is Y pressed?
    je 0f
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_SELECT_1,0f,%edx   // Is <SELECT> pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_START_1,0f,%edx    // Is <START> pressed?
    jz 0f
    orb $0x10,%al
0:  cmpl $0,_joy_up     // Is <UP> pressed?
    je 0f
    orb $0x08,%al
    jmp 1f
0:  cmpl $0,_joy_down   // Is <DOWN> pressed?
    je 0f
    orb $0x04,%al
1:
0:  cmpl $0,_joy_left   // Is <LEFT> pressed?
    je 0f
    orb $0x02,%al
    jmp 1f
0:  cmpl $0,_joy_right  // Is <RIGHT> pressed?
    je 0f
    orb $0x01,%al
1:
0:	movb %al,JOY1H
    jmp 2f
*/
controller_1_no_joystick:
    cmpb $2,_JOYSTICK_ENABLED
    jne controller_1_no_mouse

    pusha
    call _MickeyMouse
    popa
controller_1_no_mouse:
    movb $0,%al
    JUMP_VAR_KEY_UP _KEY_A_1,0f,%edx        // Is A pressed?
    orb $0x80,%al
0:  JUMP_VAR_KEY_UP _KEY_X_1,0f,%edx        // Is X pressed?
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_L_1,0f,%edx        // Is L pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_R_1,0f,%edx        // Is R pressed?
    orb $0x10,%al
0:  movb %al,JOY1L

    movb $0,%al
    JUMP_VAR_KEY_UP _KEY_B_1,0f,%edx        // Is B pressed?
    orb $0x80,%al
0:  JUMP_VAR_KEY_UP _KEY_Y_1,0f,%edx        // Is Y pressed?
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_SELECT_1,0f,%edx   // Is <SELECT> pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_START_1,0f,%edx    // Is <START> pressed?
    orb $0x10,%al
0:  JUMP_VAR_KEY_UP _KEY_UP_1,0f,%edx       // Is <UP> pressed?
    orb $8,%al
    jmp 1f
0:  JUMP_VAR_KEY_UP _KEY_DOWN_1,0f,%edx     // Is <DOWN> pressed?
    orb $4,%al
1:
0:  JUMP_VAR_KEY_UP _KEY_LEFT_1,0f,%edx     // Is <LEFT> pressed?
    orb $2,%al
    jmp 1f
0:  JUMP_VAR_KEY_UP _KEY_RIGHT_1,0f,%edx    // Is <RIGHT> pressed?
    orb $1,%al
1:
0:	movb %al,JOY1H

2:

// UPDATE CONTROLLER 2

/*  cmpb $1,_JOYSTICK_ENABLED2
    jne controller_2_no_joystick

    call _poll_joystick

    // Below needs to be rewritten to support Allegro 3.1
    movb $0,%al
    cmpl $0,_joy_b4     // Is A pressed?
    je 0f
    orb $0x80,%al
0:  cmpl $0,_joy_b2     // Is X pressed?
    je 0f
    orb $0x40,%al
0:  cmpl $0,_joy_b5     // Is L pressed?
    je 0f
    orb $0x20,%al
0:  cmpl $0,_joy_b6     // Is R pressed?
    je 0f
    orb $0x10,%al
0:	movb %al,JOY2L

    movb $0,%al
    cmpl $0,_joy_b3     // Is B pressed?
    je 0f
    orb $0x80,%al
0:  cmpl $0,_joy_b1     // Is Y pressed?
    je 0f
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_SELECT_2,0f,%edx   // Is <SELECT> pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_START_2,0f,%edx    // Is <START> pressed?
    orb $0x10,%al
0:  cmpl $0,_joy_up     // Is <UP> pressed?
    je 0f
    orb $0x08,%al
    jmp 1f
0:  cmpl $0,_joy_down   // Is <DOWN> pressed?
    je 0f
    orb $0x04,%al
1:
0:  cmpl $0,_joy_left   // Is <LEFT> pressed?
    je 0f
    orb $0x02,%al
    jmp 1f
0:  cmpl $0,_joy_right  // Is <RIGHT> pressed?
    je 0f
    orb $0x01,%al
1:
0:	movb %al,JOY2H
    jmp 2f
*/
controller_2_no_joystick:
    cmpb $2,_JOYSTICK_ENABLED2
    jne controller_2_no_mouse

    pusha
    call _MickeyMouse
    popa
controller_2_no_mouse:
    movb $0,%al
    JUMP_VAR_KEY_UP _KEY_A_2,0f,%edx        // Is A pressed?
    orb $0x80,%al
0:  JUMP_VAR_KEY_UP _KEY_X_2,0f,%edx        // Is X pressed?
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_L_2,0f,%edx        // Is L pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_R_2,0f,%edx        // Is R pressed?
    orb $0x10,%al
0:	movb %al,JOY2L

    movb $0,%al
    JUMP_VAR_KEY_UP _KEY_B_2,0f,%edx        // Is B pressed?
    orb $0x80,%al
0:  JUMP_VAR_KEY_UP _KEY_Y_2,0f,%edx        // Is Y pressed?
    orb $0x40,%al
0:  JUMP_VAR_KEY_UP _KEY_SELECT_2,0f,%edx   // Is <SELECT> pressed?
    orb $0x20,%al
0:  JUMP_VAR_KEY_UP _KEY_START_2,0f,%edx    // Is <START> pressed?
    orb $0x10,%al
0:  JUMP_VAR_KEY_UP _KEY_UP_2,0f,%edx       // Is <UP> pressed?
    orb $8,%al
    jmp 1f
0:  JUMP_VAR_KEY_UP _KEY_DOWN_2,0f,%edx     // Is <DOWN> pressed?
    orb $4,%al
1:
0:  JUMP_VAR_KEY_UP _KEY_LEFT_2,0f,%edx     // Is <LEFT> pressed?
    orb $2,%al
    jmp 1f
0:  JUMP_VAR_KEY_UP _KEY_RIGHT_2,0f,%edx    // Is <RIGHT> pressed?
    orb $1,%al
1:
0:	movb %al,JOY2H
2:  popa
    ret

ALIGNC
UPDATE_JOYSTICKS:
// Update joystick if enabled
/*
    cmpb $1,_JOYSTICK_ENABLED
    je  0f
    cmpb $1,_JOYSTICK_ENABLED2
    jne 1f

0:  pusha
    call _poll_joystick
    popa
*/
1:  ret

// Read from 21xx handlers

ALIGNC
SNES_R2116: // VMADDL
    movb VRAMAddress,%al
    ret

ALIGNC
SNES_R2117: // VMADDH
    movb VRAMAddress+1,%al
    ret

// SNES_R2134: // MPYL in Mode7.S
// SNES_R2135: // MPYM in Mode7.S
// SNES_R2136: // MPYH in Mode7.S

ALIGNC
SNES_R2137: // SLHV // This latches the counter for horizontal/vertical data!
    pushl %ebx
    andb $0x1F,IRQ_pin
    cmpb $0,CPU_Executing
    movl _65c816_Cycles,%ebx
    jnz 0f
    movl SNES_Cycles,%ebx
0:  // Set up H counters to cycles executed / 4, V counter to current scanline
    // All this below ensures bits 9-15 to be same as bits 1-7
    shrl $2,%ebx
    movb $0xFE,%al
    cmpl $128,%ebx
    jb  0f
    addl $10,%ebx   // Adjust for memory refresh cycles
0:  andb $1,%bh
    andb %bl,%al
    orb  %al,%bh
    movl %ebx,Latched_H // Cycles / 4 = rough H counter

    movl Current_Line_Timing,%ebx
    movb $0xFE,%al
    andb $1,%bh
    andb %bl,%al
    orb  %al,%bh
    movl %ebx,Latched_V

    movb $0,%al
    popl %ebx
    movb %al,OPHCT
    movb %al,OPVCT
    ret

// SNES_R2138: // OAMDATAREAD in SpriteL.S

.macro VRAM_Read_Reset
  Set_21_Read 0x39,SNES_R2139_First
  Set_21_Read 0x3A,SNES_R213A_First
  Set_21_Write 0x15,SNES_W2115_Before_VRAM_read
.endm

.macro VRAM_Read_Fixup  // VMAIN register value must be in bl
  Set_21_Write 0x15,SNES_W2115
  testb $0xC,%bl
  jz 9f
  Set_21_Read 0x39,SNES_R2139_FULL
  Set_21_Read 0x3A,SNES_R213A_FULL
  jmp 8f

ALIGNC
9:Set_21_Read 0x39,SNES_R2139_NORM
  Set_21_Read 0x3A,SNES_R213A_NORM
8:
.endm

ALIGNC
SNES_R2139_First:   // VMDATALREAD, first read
    pushl %ebx
    movl VRAMAddress,%edi
    movb _VMAIN,%bl
    testb %bl,%bl
    movb _VRAM(,%edi,2),%al
    js  0f
    VRAM_Read_Fixup
    addl SCINC,%edi
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

ALIGNC
SNES_R2139_NORM:    // VMDATALREAD, normal increment
    movl VRAMAddress,%edi
    decl %edi
    movb _VMAIN,%al
    andl $0x7FFF,%edi
    testb %al,%al
    movb _VRAM(,%edi,2),%al
    js  0f
    incl %edi
    addl SCINC,%edi
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  ret

ALIGNC
SNES_R2139_FULL:    // VMDATALREAD, full graphic increment
    movl VRAMAddress,%edi
    pushl %edx
    pushl %eax
    movl %edi,%edx
    movl %edi,%eax
    shrl $7,%edx
_2139_Bitshift=.-1
    andl $0x7F,%eax
_2139_Bitmask=.-1
    andl $7,%edx
    shll $3,%eax
    andl $0x7C00,%edi
_2139_Topmask=.-4
    orl  %eax,%edi
    popl %eax
    orl  %edx,%edi
    popl %edx
    decl %edi
    andl $0x7FFF,%edi
    movb _VMAIN,%al
    testb %al,%al
    movb _VRAM(,%edi,2),%al
    js  0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  ret

ALIGNC
SNES_R213A_First:   // VMDATAHREAD, first read
    pushl %ebx
    movl VRAMAddress,%edi
    movb _VMAIN,%bl
    testb %bl,%bl
    movb _VRAM+1(,%edi,2),%al
    jns 0f
    VRAM_Read_Fixup
    addl SCINC,%edi
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

ALIGNC
SNES_R213A_NORM:    // VMDATAHREAD, normal increment
    movl VRAMAddress,%edi
    decl %edi
    movb _VMAIN,%al
    andl $0x7FFF,%edi
    testb %al,%al
    movb _VRAM+1(,%edi,2),%al
    jns 0f
    incl %edi
    addl SCINC,%edi
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  ret

ALIGNC
SNES_R213A_FULL:    // VMDATAHREAD, full graphic increment
    movl VRAMAddress,%edi
    pushl %edx
    pushl %eax
    movl %edi,%edx
    movl %edi,%eax
    shrl $7,%edx
_213A_Bitshift=.-1
    andl $0x7F,%eax
_213A_Bitmask=.-1
    andl $7,%edx
    shll $3,%eax
    andl $0x7C00,%edi
_213A_Topmask=.-4
    orl  %eax,%edi
    popl %eax
    orl  %edx,%edi
    popl %edx
    decl %edi
    andl $0x7FFF,%edi
    movb _VMAIN,%al
    testb %al,%al
    movb _VRAM+1(,%edi,2),%al
    jns 0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  ret

ALIGNC
SNES_R213B: // CGDATAREAD

    pushl %ebx
    xorl %ebx,%ebx
    movb CGReadOdd,%bl
    movl CGAddress,%edi
    movb _Real_SNES_Palette(%ebx,%edi,2),%al
    xorb $1,%bl
    movb %bl,CGReadOdd
    jnz 0f
    incl %edi
    andl $0xFF,%edi         // Ensure address wraps correctly!
    movl %edi,CGAddress
0:  popl %ebx
    ret

ALIGNC
SNES_R213C: // OPHCT
    xorb $1,OPHCT
    jz  0f
    movb Latched_H,%al
    ret
0:  movb Latched_H+1,%al
    ret

ALIGNC
SNES_R213D: // OPVCT
    xorb $1,OPVCT
    jz  0f
    movb Latched_V,%al
    ret
0:  movb Latched_V+1,%al
    ret

ALIGNC
SNES_R213E: // STAT77
    movb $1,%al        // This is not supported yet!
    ret

ALIGNC
SNES_R213F: // STAT78
    movb $0,%al
    movb %al,OPHCT
    movb %al,OPVCT
    movb STAT78,%al
    orb _SNES_COUNTRY,%al  // 0x10 means PAL, not NTSC
    ret

// SNES_R2140_SKIP: // APUI00 in APUskip.S
// SNES_R2141_SKIP: // APUI01 in APUskip.S
// SNES_R2142_SKIP: // APUI02 in APUskip.S
// SNES_R2143_SKIP: // APUI03 in APUskip.S

// SNES_R2140_SPC:  // SPCI00 in SPCmain.S
// SNES_R2141_SPC:  // SPCI01 in SPCmain.S
// SNES_R2142_SPC:  // SPCI02 in SPCmain.S
// SNES_R2143_SPC:  // SPCI03 in SPCmain.S

ALIGNC
SNES_R2180: // WMDATA
    movl WMADDL,%edi
    movb _WRAM(%edi),%al
    incl %edi
    andl $0x01FFFF,%edi
    movl %edi,WMADDL
    ret

ALIGNC
SNES_R2181: // WMADDL
    movb WMADDL,%al
    ret

ALIGNC
SNES_R2182: // WMADDM
    movb WMADDM,%al
    ret

ALIGNC
SNES_R2183: // WMADDH
    movb WMADDH,%al
    ret

ALIGNC
SNES_R21C2: // Unknown? SNES test cart reads it, returning same value as 9X
    movb $0x20,%al
    ret

ALIGNC
SNES_R21C3: // Unknown? SNES test cart reads it, returning same value as 9X
    movb $0,%al
    ret

// Read from 40xx handlers
/*
 SNEeSe 0.13, random speculation time, this register or at least bit 0
  handles input for controller 1

 v0.15 17th bit is an indication of joypad connected status

 $4016 is very similar in function (almost identical) to the register at
  the same address on the NES/Famicom

*/

ALIGNC
SNES_R4016: // JOYC1
    testb $1,JOYC1
    jz  1f
    movb $0,%al
    ret
1:  push %ecx
    push %ebx
    cmpb $2,_JOYSTICK_ENABLED   // Is mouse plugged in?
    je  Do_Mouse_4016

1:  movb Controller1_Pos,%cl
    decb %cl
    movl JOY1L,%ebx
    movb %cl,Controller1_Pos
    rorl %cl,%ebx
    movb %bl,%al
    andb $1,%al
    pop %ebx
    pop %ecx
    ret
0:  movb $16,Controller1_Pos
    movb $1,%al             // Joypad connected
    pop %ebx
    pop %ecx
    ret

ALIGNC
Do_Mouse_4016:
    movb Controller1_Pos,%cl
    decb %cl
    andb $0x0F,%cl
    movb %cl,Controller1_Pos
    movw _MickeyRead,%bx
    shrw %cl,%bx
    movb %bl,%al
    andb $1,%al
    pop %ebx
    pop %ecx
    ret

ALIGNC
SNES_R4017: // JOYC2
    testb $1,JOYC1
    jz  1f
    movb $0,%al
    ret
1:  push %ecx
    push %ebx
    cmpb $2,_JOYSTICK_ENABLED2  // Is mouse plugged in?
    je  Do_Mouse_4017

1:  movb Controller23_Pos,%cl
    decb %cl
    movl JOY2L,%ebx
    movb %cl,Controller23_Pos
    rorl %cl,%ebx
    movb %bl,%al
    andb $1,%al
    pop %ebx
    pop %ecx
    ret
0:  movb $16,Controller23_Pos
    movb $1,%al // (???) Return 0 this bit is for mtap I think
    pop %ebx
    pop %ecx
    ret

ALIGNC
Do_Mouse_4017:
    movb Controller23_Pos,%cl
    decb %cl
    andb $0x0F,%cl
    movb %cl,Controller23_Pos
    movw _MickeyRead,%bx
    shrw %cl,%bx
    movb %bl,%al
    andb $1,%al
    pop %ebx
    pop %ecx
    ret

// Read from 42xx handlers
ALIGNC
SNES_R4202: // WRMPYA
    movb WRMPYA,%al
    ret

ALIGNC
SNES_R4203: // WRMPYB
    movb WRMPYB,%al
    ret

ALIGNC
SNES_R4210: // RDNMI
    movb RDNMI,%al
    movb $2,RDNMI           // NMI on/off + version #
    ret

ALIGNC
SNES_R4211: // TIMEUP
    // Should return bit 7 set if IRQ active, bit 6 set if cur line = V count
    movb TIMEUP,%al
    movb $0,TIMEUP
    movl Current_Line_Timing,%edi
    andb $0x1F,IRQ_pin  // Clear H/V IRQ
    cmpl %edi,VTIMEL
    jne 0f
    orb $0x40,%al
0:  ret

ALIGNC
SNES_R4200: // NMITIMEN
SNES_R4212: // HVBJOY
// Excerpts: Neill Corlett's "SNES Timing: The Brutal Truth" Version: 1.0b
//  <-22 dots-> <------------256 dots--------------> <-62 dots->
// 5. Something freaky
// -------------------
// On every scanline, starting at dot 128, the CPU appears to be frozen for 40
// master cycles.  DMA is also apparently frozen during this time.  This happens
// whether the scanline is visible or not, and whether HDMA is enabled or not.
//
// My current theory is that this time is used for refreshing RAM.
// *End excerpts*
    movl _65c816_Cycles,%edi
    movb HVBJOY,%al
    cmpl $(22+256-10)*4,%edi    // Hblank after display
    jae 0f
    cmpl $(22*4),%edi           // Hblank before display
    jae 1f
0:  orb $0x40,%al   // We're in Hblank...
1:  ret

ALIGNC
SNES_R4213: // RDIO
    movb $0xFF,%al      // v0.14 - not supported but returns a value
    ret

ALIGNC
SNES_R4214: // RDDIVL
    movb RDDIVL,%al
    ret

ALIGNC
SNES_R4215: // RDDIVH
    movb RDDIVH,%al
    ret

ALIGNC
SNES_R4216: // RDMPYL
    movb RDMPYL,%al
    ret

ALIGNC
SNES_R4217: // RDMPYH
    movb RDMPYH,%al
    ret

ALIGNC
SNES_R4218: // JOY1L
    movb JOY1L,%al
    cmpb $2,_JOYSTICK_ENABLED   // Is mouse plugged in?
    je  1f
    ret
1:  orb $0x01,%al
    orb _MouseButts,%al
    ret

ALIGNC
SNES_R4219: // JOY1H
    movb JOY1H,%al
    ret

ALIGNC
SNES_R421A: // JOY2L
    movb JOY2L,%al
    cmpb $2,_JOYSTICK_ENABLED2  // Is mouse plugged in?
    je  1f
    ret
1:  orb $0x01,%al
    orb _MouseButts,%al
    ret

ALIGNC
SNES_R421B: // JOY2H
    movb JOY2H,%al
    ret

ALIGNC
SNES_R421C: // JOY3L
    movb JOY3L,%al
    ret

ALIGNC
SNES_R421D: // JOY3H
    movb JOY3H,%al
    ret

ALIGNC
SNES_R421E: // JOY4L
    movb JOY4L,%al
    ret

ALIGNC
SNES_R421F: // JOY4H
    movb JOY4H,%al
    ret

// Read from 43xx handlers
// SNES_R43xx: // in DMA.S

/*  --------   */

// Write to 21xx handlers
ALIGNC
.globl SNES_W2100
SNES_W2100: // INIDISP
    cmpb %al,_INIDISP
    je  0f
    SyncRender
    movb %al,_INIDISP
    andb $0x0F,%al
    cmpb %al,_BrightnessLevel
    ja  1f
    movb %al,_BrightnessLevel   // Sets the brightness level for SetPalette
    movb $1,PaletteChanged
1:  movb _INIDISP,%al
0:  ret

// SNES_W2101: // OBSEL in SpriteL.S
// SNES_W2102: // OAMADDL in SpriteL.S
// SNES_W2103: // OAMADDH in SpriteL.S
// SNES_W2104: // OAMDATA in SpriteL.S

.globl Toggle_Offset_Change
ALIGNC
Toggle_Offset_Change:
    pusha
    xorb $0xFF,Offset_Change_Disable
    jz  0f
    movl $RENDER_8x8_C4,LineRenderSmall+6*4
    jmp 1f
ALIGNC
0:  movl $RENDER_8x8_C4_Offset,LineRenderSmall+6*4
1:  movb _BGMODE,%al
    testb $1,%al
    jnz 0f
    movb %al,%bl
    andl $7,%ebx
    jz  0f

    cmpl $5,%ebx
    jae 5f

    testb $0x10,%al
    movb DepthBG1,%bl
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG1

    movb DepthBG2,%bl
    testb $0x20,%al
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG2

    movb DepthBG3,%bl
    testb $0x40,%al
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG3

    movb DepthBG4,%bl
    testb %al,%al
    movl LineRenderLarge(,%ebx,4),%edi
    js  1f
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG4

0:  popa
    ret

ALIGNC
5:  movb DepthBG1,%bl
    testb $0x10,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG1

    movb DepthBG2,%bl
    testb $0x20,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG2

    movb DepthBG3,%bl
    testb $0x40,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG3

    movb DepthBG4,%bl
    testb %al,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    js  1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %edi,LineRenderBG4

    popa
    ret

ALIGNC
SNES_W2105: // BGMODE
    // Note: Render_Mode is declared in ScreenL.S
    cmpb %al,_BGMODE
    je  0f
    SyncRender  //*
    pushl %ebx
    pushl %ecx
    movl %eax,%edi
    movb %al,_BGMODE
    andl $7,%edi
    movb $0x0F,Redo_BGs

    xorl %ebx,%ebx
    leal BGMODE_Depth_Table(,%edi,4),%ecx
    movl Screen_Mode(,%edi,4),%edi
    movl %edi,Render_Mode

    movb (%ecx),%bl
    movb %bl,DepthBG1

    movb 1(%ecx),%bl
    movb %bl,DepthBG2

    movb 2(%ecx),%bl
    movb %bl,DepthBG3

    movb 3(%ecx),%bl
    movb %bl,DepthBG4

    movb DepthBG1,%cl
    movb NBABG1,%bl
    andl $3,%ecx
    jz  9f
    movl Depth_NBA_Table(,%ecx,4),%ecx
    movl %ecx,NBATableBG1
    movl (%ecx,%ebx,4),%ecx
    movl %ecx,SetAddressBG1

    testb $0x10,%al     // get (tile height / 8) for BG1
    movb $2,%bl
    jnz 8f
    movb $1,%bl
8:  movb %bl,TileHeightBG1
    movb %bl,TileWidthBG1

    movb DepthBG2,%cl
    movb NBABG2,%bl
    andl $3,%ecx
    jz  9f
    movl Depth_NBA_Table(,%ecx,4),%ecx
    movl %ecx,NBATableBG2
    movl (%ecx,%ebx,4),%ecx
    movl %ecx,SetAddressBG2

    testb $0x20,%al     // get (tile height / 8) for BG2
    movb $2,%bl
    jnz 8f
    movb $1,%bl
8:  movb %bl,TileHeightBG2
    movb %bl,TileWidthBG2

    testb $0x40,%al     // get (tile height / 8) for BG3
    movb $2,%bl
    jnz 8f
    movb $1,%bl
8:  movb %bl,TileHeightBG3
    movb %bl,TileWidthBG3

    testb %al,%al     // get (tile height / 8) for BG4
    movb $2,%bl
    js  8f
    movb $1,%bl
8:  movb %bl,TileHeightBG4
    movb %bl,TileWidthBG4

9:  movl %eax,%edi
    andl $7,%edi
    xorl %ebx,%ebx
    cmpl $5,%edi
    jae 5f

    movb DepthBG1,%bl
    testb $0x10,%al
    movl $Redo_16,%ecx
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl $Redo_8,%ecx
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG1
    movl %edi,LineRenderBG1

    movb DepthBG2,%bl
    testb $0x20,%al
    movl $Redo_16,%ecx
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl $Redo_8,%ecx
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG2
    movl %edi,LineRenderBG2

    movb DepthBG3,%bl
    testb $0x40,%al
    movl $Redo_16,%ecx
    movl LineRenderLarge(,%ebx,4),%edi
    jnz 1f
    movl $Redo_8,%ecx
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG3
    movl %edi,LineRenderBG3

    movb DepthBG4,%bl
    testb %al,%al
    movl $Redo_16,%ecx
    movl LineRenderLarge(,%ebx,4),%edi
    js  1f
    movl $Redo_8,%ecx
    movl LineRenderSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG4
    movl %edi,LineRenderBG4

    popl %ecx
    popl %ebx
0:  ret

ALIGNC
// Mode 5/6: uses half-wide tile counts for half-512
5:  movb $2,%bl
    // 16-wide tiles on background layers always
    movb %bl,TileWidthBG1
    movb %bl,TileWidthBG2
    movb %bl,TileWidthBG3
    movb %bl,TileWidthBG4

    movl $Redo_16_Mode_5_6,%ecx
    movb DepthBG1,%bl
    testb $0x10,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG1
    movl %edi,LineRenderBG1

    movb DepthBG2,%bl
    testb $0x20,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG2
    movl %edi,LineRenderBG2

    movb DepthBG3,%bl
    testb $0x40,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    jnz 1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG3
    movl %edi,LineRenderBG3

    movb DepthBG4,%bl
    testb %al,%al
    movl LineRenderEvenLarge(,%ebx,4),%edi
    js  1f
    movl LineRenderEvenSmall(,%ebx,4),%edi
1:  movl %ecx,Redo_BG4
    movl %edi,LineRenderBG4

    popl %ecx
    popl %ebx
    ret

ALIGNC
Redo_0:
    ret

ALIGNC
Redo_8:
Redo_16_Mode_5_6:
    movb HScroll(%edx),%al
    testb %al,%al   // If 0 simply plot 32 tiles
    jz  0f

    movb %al,%cl
    movl $0x100,%ebx
    andl $0xF8,%ecx
    andl $0x07,%eax
    subl %ecx,%ebx
    movl %eax,FirstPixel(%edx)
    shrl $3,%ebx
    movb %bl,%ch
    movb $32,%bl
    subb %ch,%bl
    movb %ch,TileCount1(%edx)
    testb %al,%al
    movb %bl,%ah
    jz  1f
    incb %ah
1:  addl %ebx,%ebx
    movb %ah,TileCount2(%edx)
    movl %ebx,FirstTile(%edx)
    ret
ALIGNC
0:  xorl %eax,%eax
    movb $32,TileCount1(%edx)
    movl %eax,FirstPixel(%edx)
    movl %eax,FirstTile(%edx)
    movb %al,TileCount2(%edx)
    ret

ALIGNC
Redo_16:
    movl HScroll(%edx),%eax
    testl $0x1FF,%eax   // If 0 simply plot 16 tiles
    jz  0f

    movb %al,%cl
    movl $0x20,%ebx
    shrl $4,%eax
    andl $0x0F,%ecx
    andl $0x1F,%eax
    subl %eax,%ebx
    addl %eax,%eax
    movl %ecx,FirstPixel(%edx)
    movl %eax,FirstTile(%edx)
    movb $16,%al
    cmpb $16,%bl
    ja  2f
    subb %bl,%al
    movb %bl,TileCount1(%edx)
    testb %cl,%cl
    jz  1f
    incb %al
1:  movb %al,TileCount2(%edx)
    ret

2:  movb $0,TileCount2(%edx)
    testb %cl,%cl
    movb $16,%al
    jz  1f
    movb $17,%al
1:  movb %al,TileCount1(%edx)
    ret
ALIGNC
0:  xorl %eax,%eax
    movb $16,TileCount1(%edx)
    movl %eax,FirstPixel(%edx)
    movl %eax,FirstTile(%edx)
    movb %al,TileCount2(%edx)
    ret

ALIGNC
SNES_W2106: // MOSAIC
    cmpb %al,MOSAIC
    je  0f
    SyncRender  //*
    testb $0xF0,%al
    movb %al,MOSAIC
    movl %eax,%edi
    jnz 1f
    xorb %al,%al
    movb %al,MosaicBG1
    movb %al,MosaicBG2
    movb %al,MosaicBG3
    movb %al,MosaicBG4
    movl %edi,%eax
    ret
ALIGNC
1:  andb $0x01,%al
    movb %al,MosaicBG1
    movl %edi,%eax
    andb $0x02,%al
    movb %al,MosaicBG2
    movl %edi,%eax
    andb $0x04,%al
    movb %al,MosaicBG3
    movl %edi,%eax
    andb $0x08,%al
    movb %al,MosaicBG4
    movl %edi,%eax
    shrl $4,%edi
    andl $15,%edi
    incl %edi
    movl %edi,Mosaic_Size
0:  ret

ALIGNC
SNES_W2107: // BG1SC
    SyncRender  //*
    pushl %ebx
    movb %al,_BG1SC
    movb %al,%bl
    andb $3,%bl
    movb %bl,_BGSC1
    movl %eax,%edi
    andl $0x7C,%edi
    shll $9,%edi        //8
    addl $_VRAM,%edi
    movl %edi,MapAddressBG1

    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,TRMapAddressBG1
    testb $2,%al
    movl TLMapAddressBG1,%edi
    jz 0f
    movl TRMapAddressBG1,%edi
    addl $32*32*2,%edi
0:  movl %edi,BLMapAddressBG1
    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,BRMapAddressBG1

    popl %ebx
    ret

ALIGNC
SNES_W2108: // BG2SC
    SyncRender  //*
    pushl %ebx
    movb %al,_BG2SC
    movb %al,%bl
    andb $3,%bl
    movb %bl,_BGSC2
    movl %eax,%edi
    andl $0x7C,%edi
    shll $9,%edi        //8
    addl $_VRAM,%edi
    movl %edi,MapAddressBG2

    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,TRMapAddressBG2
    testb $2,%al
    movl TLMapAddressBG2,%edi
    jz 0f
    movl TRMapAddressBG2,%edi
    addl $32*32*2,%edi
0:  movl %edi,BLMapAddressBG2
    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,BRMapAddressBG2

    popl %ebx
    ret

ALIGNC
SNES_W2109: // BG3SC
    SyncRender  //*
    pushl %ebx
    movb %al,_BG3SC
    movb %al,%bl
    andb $3,%bl
    movb %bl,_BGSC3
    movl %eax,%edi
    andl $0x7C,%edi
    shll $9,%edi        //8
    addl $_VRAM,%edi
    movl %edi,MapAddressBG3

    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,TRMapAddressBG3
    testb $2,%al
    movl TLMapAddressBG3,%edi
    jz 0f
    movl TRMapAddressBG3,%edi
    addl $32*32*2,%edi
0:  movl %edi,BLMapAddressBG3
    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,BRMapAddressBG3

    movl _BG3VOFS,%edi
    movl %edi,%ebx
    shll $3,%edi            // divided by 8 (base tile size),
    andl $(0x1F << 6),%edi  // * 2 (16-bit words) * 32 (row)
    testb $1,%bh
    movl BLMapAddressBG3,%ebx
    jnz 0f
    movl TLMapAddressBG3,%ebx
0:  addl %ebx,%edi
#ifdef NO_H_SIZE_ON_OFFSET_MAP
    popl %ebx
    movl %edi,OffsetChangeMap_VOffset
#else   // !NO_H_SIZE_ON_OFFSET_MAP
    movl %edi,OffsetChangeMap_VOffset

    movl _BG3HOFS,%edi
    testb $1,BG3SC
    movl $(0x3F << 1),%ebx
    jz  0f
    movl $(0x1F << 1),%ebx
0:  shrl $2,%edi            // divided by 8 (base tile size),
    andl %ebx,%edi
    popl %ebx
    movl %edi,OffsetChangeMap_HOffset
#endif  // !NO_H_SIZE_ON_OFFSET_MAP

    ret

ALIGNC
SNES_W210A: // BG4SC
    SyncRender  //*
    pushl %ebx
    movb %al,_BG4SC
    movb %al,%bl
    andb $3,%bl
    movb %bl,_BGSC4
    movl %eax,%edi
    andl $0x7C,%edi
    shll $9,%edi        //8
    addl $_VRAM,%edi
    movl %edi,MapAddressBG4

    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,TRMapAddressBG4
    testb $2,%al
    movl TLMapAddressBG4,%edi
    jz 0f
    movl TRMapAddressBG4,%edi
    addl $32*32*2,%edi
0:  movl %edi,BLMapAddressBG4
    testb $1,%al
    jz 0f
    addl $32*32*2,%edi
0:  movl %edi,BRMapAddressBG4

    popl %ebx
    ret

ALIGNC
SNES_W210B: // BG12NBA
    SyncRender  //*
    pushl %ebx
    movb %al,_BG12NBA
    movb %al,%bl
    andl $7,%ebx
    movl NBATableBG1,%edi
    movb %bl,NBABG1
    movl (%edi,%ebx,4),%ebx
    movl %ebx,SetAddressBG1
    movb %al,%bl
    shrl $4,%ebx
    andl $7,%ebx
    movl NBATableBG2,%edi
    movb %bl,NBABG2
    movl (%edi,%ebx,4),%ebx
    movl %ebx,SetAddressBG2
    popl %ebx
    ret

ALIGNC
SNES_W210C: // BG34NBA
    SyncRender  //*
    pushl %ebx
    movb %al,_BG34NBA

    movb %al,%bl
    andl $7,%ebx
    shll $15,%ebx   // * 8k * 4 (2bpl)
    movl %ebx,SetAddressBG3

    movb %al,%bl
    shrl $4,%ebx
    andl $7,%ebx
    shll $15,%ebx   // * 8k * 4 (2bpl)
    movl %ebx,SetAddressBG4

    popl %ebx
    ret

ALIGNC
SNES_W210D: // BG1HOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG1HOFS+1,%al
    movw %ax,_BG1HOFS

    shll $0x13,%eax
    sarl $0x13,%eax
    movl %eax,_M7H
    movb $0x05,%al  // Recalculate A and C
    orb  %al,Redo_M7

    movb $1,%al
    orb  %al,Redo_BGs

    popl %eax
    ret

ALIGNC
SNES_W210E: // BG1VOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG1VOFS+1,%al
    movw %ax,_BG1VOFS

    shll $0x13,%eax
    sarl $0x13,%eax
    movl %eax,_M7V
    movb $0x0A,%al  // Recalculate B and D
    orb  %al,Redo_M7
    popl %eax
    ret

ALIGNC
SNES_W210F: // BG2HOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG2HOFS+1,%al
    movw %ax,_BG2HOFS

    movb $2,%al
    orb  %al,Redo_BGs

    popl %eax
    ret

ALIGNC
SNES_W2110: // BG2VOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG2VOFS+1,%al
    movw %ax,_BG2VOFS
    popl %eax
    ret

ALIGNC
SNES_W2111: // BG3HOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG3HOFS+1,%al
    movl %eax,%edi
    shrl $2,%edi            // divided by 8 (base tile size),
    movw %ax,_BG3HOFS
/**/
#ifndef NO_H_SIZE_ON_OFFSET_MAP
    testb $1,BG3SC
    movl $(0x3F << 1),%eax
    jz  0f
    movl $(0x1F << 1),%eax
0:  andl %eax,%edi
#else
    andl $(0x1F << 1),%edi  // * 2 (16-bit words)
#endif
    movl %edi,OffsetChangeMap_HOffset

    movb $4,%al
    orb  %al,Redo_BGs

    popl %eax
    ret

ALIGNC
SNES_W2112: // BG3VOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG3VOFS+1,%al
    movl %eax,%edi
    shll $3,%edi            // divided by 8 (base tile size),
    movw %ax,_BG3VOFS
    andl $(0x1F << 6),%edi  // * 2 (16-bit words) * 32 (row)
    testb $1,%ah
    movl BLMapAddressBG3,%eax
    jnz 0f
    movl TLMapAddressBG3,%eax
0:  addl %eax,%edi
    popl %eax
    movl %edi,OffsetChangeMap_VOffset
    ret

ALIGNC
SNES_W2113: // BG4HOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG4HOFS+1,%al
    movw %ax,_BG4HOFS

    movb $8,%al
    orb  %al,Redo_BGs

    popl %eax
    ret

ALIGNC
SNES_W2114: // BG4VOFS
    SyncRender  //*scroll
    pushl %eax
    movb %al,%ah
    movb _BG4VOFS+1,%al
    movw %ax,_BG4VOFS
    popl %eax
    ret

ALIGNC
SNES_W2115_Before_VRAM_read: // VMAIN
    movb %al,_VMAIN         // Get our copy of this
    andb $0xC,%al
    jz 0f
    Set_21_Write 0x18,SNES_W2118_FULL
    Set_21_Write 0x19,SNES_W2119_FULL
    cmpb $2*4,%al
    je  2f
    ja  3f
1:  movb $5,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x1F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7F00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
2:  movb $6,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x3F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7E00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
3:  movb $7,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x7F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7C00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
0:  Set_21_Write 0x18,SNES_W2118_NORM
    Set_21_Write 0x19,SNES_W2119_NORM
1:  movb _VMAIN,%al
    andb $3,%al
    jnz 0f

    movb $1,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
0:  cmpb $2,%al
    jae 2f

1:  movb $32,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
2:  // A bug in SNES makes this 128
3:  movb $128,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
SNES_W2115: // VMAIN
    movb %al,_VMAIN         // Get our copy of this
    andb $0xC,%al
    jz 0f
    Set_21_Read 0x39,SNES_R2139_FULL
    Set_21_Read 0x3A,SNES_R213A_FULL
    Set_21_Write 0x18,SNES_W2118_FULL
    Set_21_Write 0x19,SNES_W2119_FULL
    cmpb $2*4,%al
    je  2f
    ja  3f
1:  movb $5,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x1F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7F00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
2:  movb $6,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x3F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7E00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
3:  movb $7,%al
    movb %al,_2118_Bitshift
    movb %al,_2119_Bitshift
    movb %al,_2139_Bitshift
    movb %al,_213A_Bitshift
    movb $0x7F,%al
    movb %al,_2118_Bitmask
    movb %al,_2119_Bitmask
    movb %al,_2139_Bitmask
    movb %al,_213A_Bitmask
    movl $0x7C00,%edi
    movl %edi,_2118_Topmask
    movl %edi,_2119_Topmask
    movl %edi,_2139_Topmask
    movl %edi,_213A_Topmask
    jmp 1f

ALIGNC
0:  Set_21_Read 0x39,SNES_R2139_NORM
    Set_21_Read 0x3A,SNES_R213A_NORM
    Set_21_Write 0x18,SNES_W2118_NORM
    Set_21_Write 0x19,SNES_W2119_NORM
1:  movb _VMAIN,%al
    andb $3,%al
    jnz 0f

    movb $1,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
0:  cmpb $2,%al
    jae 2f

1:  movb $32,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
2:  // A bug in SNES makes this 128
3:  movb $128,SCINC
    movb _VMAIN,%al
    ret

ALIGNC
SNES_W2116: // VMADDL
    VRAM_Read_Reset
    movb %al,VRAMAddress
    ret

ALIGNC
SNES_W2117: // VMADDH
    pushl %eax
    andb $0x7F,%al
    VRAM_Read_Reset
    movb %al,VRAMAddress+1
    popl %eax
    ret

.macro VRAM_Cache_Check
/*  Check upper boundary
    Check within set (?)
 */
#ifdef Set_Based_Tile_Cache
    movl Tile_Recache_Set_End,%ebx
#endif
    shrl $3,%edi
#ifdef Set_Based_Tile_Cache
    subl %edi,%ebx
    je  3f  // Simplest case - tile is end of set
#ifdef Check_Within_Tile_Set
    jg  1f  // Tile may be within set?
#else
    jg  2f
#endif
    // Tile may be immediately after set?
    cmpl $-1,%ebx
#ifdef Check_Within_Tile_Set
    jne 2f
    jmp 5f
1:  // Tile may be within set?
    cmpl %edi,Tile_Recache_Set_Begin
    jle 3f
#else
    je  5f
#endif
2:  // New set
    pushl %edi
    movl Tile_Recache_Set_End,%edi
    incl %edi
    js  4f  // No set to recache?
    subl Tile_Recache_Set_Begin,%edi
#ifdef Profile_Recache_Sets
    addl %edi,Tiles_Recached
#endif
    call Recache_Tile_Set
#ifdef Profile_Recache_Sets
    incl Sets_Recached
#endif
4:  popl %edi
    movl %edi,Tile_Recache_Set_Begin
5:  movl %edi,Tile_Recache_Set_End
3:
#endif
#ifdef Tile_Cache_Uses_Dirty_Flags
    xorb %bh,%bh
    movb %bh,_CacheDirty2(%edi) // Invalidate cache entry
    shrl $1,%edi
    movb %bh,_CacheDirty4(%edi)
    shrl $1,%edi
    movb %bh,_CacheDirty8(%edi)
#endif
.endm

ALIGNC
SNES_W2118_NORM: // VMDATAL, normal increment
    pushl %ebx
    movl $_VRAM,%ebx
    movl VRAMAddress,%edi
    VRAM_Read_Reset
    cmpb %al,(%ebx,%edi,2)
    je  0f
    pushl %edi
    SyncRender  //*
    popl %edi
#ifdef Profile_VRAM_Writes
    incl VMWriteL_Norm
#endif
    movb %al,(%ebx,%edi,2)
    movb %al,_VRAM_DI(%edi)
    VRAM_Cache_Check
0:  movb _VMAIN,%bl
    testb %bl,%bl
    js  0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

ALIGNC
SNES_W2118_FULL: // VMDATAL, full graphic increment
    pushl %ebx
    movl VRAMAddress,%edi
    pushl %edx
    pushl %eax
    movl %edi,%edx
    movl %edi,%eax
    shrl $7,%edx
_2118_Bitshift=.-1
    andl $0x7F,%eax
_2118_Bitmask=.-1
    andl $7,%edx
    shll $3,%eax
    andl $0x7C00,%edi
_2118_Topmask=.-4
    orl  %eax,%edi
    popl %eax
    orl  %edx,%edi
    popl %edx
    movl $_VRAM,%ebx
    VRAM_Read_Reset
    cmpb %al,(%ebx,%edi,2)
    je  0f
    pushl %edi
    SyncRender  //*
    popl %edi
#ifdef Profile_VRAM_Writes
    incl VMWriteL_Full
#endif
    movb %al,(%ebx,%edi,2)
    movb %al,_VRAM_DI(%edi)
    VRAM_Cache_Check
0:  movb _VMAIN,%bl
    testb %bl,%bl
    js  0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

ALIGNC
SNES_W2119_NORM: // VMDATAH, normal increment
    pushl %ebx
    movl $_VRAM+1,%ebx
    movl VRAMAddress,%edi
    VRAM_Read_Reset
    cmpb %al,(%ebx,%edi,2)
    je  0f
    pushl %edi
    SyncRender  //*
    popl %edi
#ifdef Profile_VRAM_Writes
    incl VMWriteH_Norm
#endif
    movb %al,(%ebx,%edi,2)
    movb %al,_VRAM_DI+32768(%edi)
    VRAM_Cache_Check
0:  movb _VMAIN,%bl
    testb %bl,%bl
    jns 0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

ALIGNC
SNES_W2119_FULL: // VMDATAH, full graphic increment
    pushl %ebx
    movl VRAMAddress,%edi
    pushl %edx
    pushl %eax
    movl %edi,%edx
    movl %edi,%eax
    shrl $7,%edx
_2119_Bitshift=.-1
    andl $0x7F,%eax
_2119_Bitmask=.-1
    andl $7,%edx
    shll $3,%eax
    andl $0x7C00,%edi
_2119_Topmask=.-4
    orl  %eax,%edi
    popl %eax
    orl  %edx,%edi
    popl %edx
    movl $_VRAM+1,%ebx
    VRAM_Read_Reset
    cmpb %al,(%ebx,%edi,2)
    je  0f
    pushl %edi
    SyncRender  //*
    popl %edi
#ifdef Profile_VRAM_Writes
    incl VMWriteH_Full
#endif
    movb %al,(%ebx,%edi,2)
    movb %al,_VRAM_DI+32768(%edi)
    VRAM_Cache_Check
0:  movb _VMAIN,%bl
    testb %bl,%bl
    jns 0f
    movl SCINC,%edi
    addl VRAMAddress,%edi   // Always words (since <<1)!
    andl $0x7FFF,%edi
    movl %edi,VRAMAddress
0:  popl %ebx
    ret

// SNES_W211A: // M7SEL in Mode7.S
// SNES_W211B: // M7A in Mode7.S
// SNES_W211C: // M7B in Mode7.S
// SNES_W211D: // M7C in Mode7.S
// SNES_W211E: // M7D in Mode7.S
// SNES_W211F: // M7X in Mode7.S
// SNES_W2120: // M7Y in Mode7.S

ALIGNC
SNES_W2121: // CGADD
    pushl %eax
    xorl %eax,%eax
    movb %al,CGOdd
    movb %al,CGReadOdd
    movb (%esp),%al
    movl %eax,CGAddress
    popl %eax
    ret	

ALIGNC
SNES_W2122: // CGDATA
    /* Palette should be set even if just lo byte set! */
    /* We now set the palette in CGRAM */

//  SyncRender  //*16-bit rendering only
    pushl %ebx
    xorl %ebx,%ebx
    movb CGOdd,%bl
    movl CGAddress,%edi
    cmpb _Real_SNES_Palette(%ebx,%edi,2),%al
    jz  0f
    movb $1,PaletteChanged
//  cmpl LastChangedColor,%edi
//1:
    movb %al,_Real_SNES_Palette(%ebx,%edi,2)
0:  xorb $1,%bl
    movb %bl,CGOdd
    jnz 0f
    incl %edi
    andl $0xFF,%edi         // Ensure address wraps correctly!
    movl %edi,CGAddress
0:  popl %ebx
    ret

ALIGNC
SNES_W2123: // W12SEL
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_W12SEL
    ret

ALIGNC
SNES_W2124: // W34SEL
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_W34SEL
    ret

ALIGNC
SNES_W2125: // WOBJSEL
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WOBJSEL
    ret

ALIGNC
SNES_W2126: // WH0
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WH0
    ret

ALIGNC
SNES_W2127: // WH1
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WH1
    ret

ALIGNC
SNES_W2128: // WH2
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WH2
    ret

ALIGNC
SNES_W2129: // WH3
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WH3
    ret

ALIGNC
SNES_W212A: // WBGLOG
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WBGLOG
    ret

ALIGNC
SNES_W212B: // WOBJLOG
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_WOBJLOG
    ret

ALIGNC
.globl Update_Layering
Update_Layering:
    cmpb $1,Layering_Mode
    je Update_Layering_1
    ja Update_Layering_2
Update_Layering_0:
    movl $Render_Layering_Option_0,Render_Select
    movb _TM,%al    // layering option 0: sub-on-main
    andb TM_MASK,%al
    movb %al,SCR_TM
    xorb $0xFF,%al
    andb _TS,%al
    andb TM_MASK,%al
    movb %al,SCR_TS
    ret
ALIGNC
Update_Layering_1:
    movl $Render_Layering_Option_1,Render_Select
    movb _TS,%al    // layering option 1: main-on-sub
    andb TM_MASK,%al
    movb %al,SCR_TS
    xorb $0xFF,%al
    andb _TM,%al
    andb TM_MASK,%al
    movb %al,SCR_TM
    ret
ALIGNC
Update_Layering_2:
    movl $Render_Layering_Option_2,Render_Select
    movb _TM,%al    // layering option 2: main-with-sub
    orb _TS,%al
    andb TM_MASK,%al
    movb %al,SCR_TM
    ret

ALIGNC
SNES_W212C: // TM
    SyncRender  //*
//  call Recalc_Window_Effects
    movb %al,_TM
    call Update_Layering
    movb _TM,%al
    ret

ALIGNC
SNES_W212D: // TS
    SyncRender  //*
//  call Recalc_Window_Effects
    movb %al,_TS
    call Update_Layering
    movb _TS,%al
    ret

ALIGNC
SNES_W212E: // TMW
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_TMW
    ret

ALIGNC
SNES_W212F: // TSW
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_TSW
    ret

ALIGNC
SNES_W2130: // CGWSEL
//  SyncRender  //*windowing only
//  call Recalc_Window_Effects
    movb %al,_CGWSEL
    ret

ALIGNC
SNES_W2131: // CGADSUB
    cmpb _CGADSUB,%al
    je 0f
//  SyncRender  //*16-bit rendering only
//  call Recalc_Window_Effects
    pushl %eax
    movb %al,_CGADSUB

    testb $0xA0,%al     // Hack for back area color addition
    movb $0,%ah
    jz 1f
    js 1f
    movb $-1,%ah
1:  movb %ah,_fixedpalettecheck
    popl %eax
0:  ret

ALIGNC
SNES_W2132: // COLDATA
//  SyncRender  //*16-bit rendering only
//  call Recalc_Window_Effects
    pushl %ebx
    movl _COLDATA,%edi

    testb $0xC0,%al
    jns 0f

    movb %al,%bl
    andl $0x1F,%ebx
    shll $10,%ebx

    andl $0x3FF,%edi
    orl %ebx,%edi

    testb $0x40,%al
0:  jz  0f

    movb %al,%bl
    andl $0x1F,%ebx
    shll $5,%ebx

    andl $0x7C1F,%edi
    orl %ebx,%edi

0:  testb $0x20,%al
    jz  0f

    movb %al,%bl
    andl $0x1F,%ebx

    andl $0x7FE0,%edi
    orl %ebx,%edi

0:  movl %edi,_COLDATA
    popl %ebx

    ret

ALIGNC
SNES_W2133: // SETINI
  cmpb _SETINI,%al
  je 0f
  SyncRender  //*interlaced etc. not yet supported
  testb $4,%al
  movb %al,_SETINI
  movl $239,%edi
  jnz 1f
  movl $224,%edi
1:movl %edi,LastRenderLine

  pushl %ebx
  movb _M7SEL,%al
  movb %al,%bl
  shrl $4,%ebx
  andb $3,%al
  andl $0x0C,%ebx
  orb %al,%bl

  movb _SETINI,%al  // 0.42 - Mode 7 w/ priority
  andb $0x40,%al
  shrb $2,%al
  orb %al,%bl

  movl M7_Table(,%ebx,4),%ebx
  movl %ebx,M7_Handler
  popl %ebx
  movb _SETINI,%al
0:ret

// SNES_W2140_SKIP: // APUI00 in APUskip.S
// SNES_W2141_SKIP: // APUI01 in APUskip.S
// SNES_W2142_SKIP: // APUI02 in APUskip.S
// SNES_W2143_SKIP: // APUI03 in APUskip.S

// SNES_W2140_SPC:  // SPCI00 in SPCmain.S
// SNES_W2141_SPC:  // SPCI01 in SPCmain.S
// SNES_W2142_SPC:  // SPCI02 in SPCmain.S
// SNES_W2143_SPC:  // SPCI03 in SPCmain.S

ALIGNC
SNES_W2180: // WMDATA
    movl WMADDL,%edi
    movb %al,_WRAM(%edi)
    incl %edi
    andl $0x01FFFF,%edi
    movl %edi,WMADDL
    ret

ALIGNC
SNES_W2181: // WMADDL
    movb %al,WMADDL
    ret

ALIGNC
SNES_W2182: // WMADDM
    movb %al,WMADDM
    ret

ALIGNC
SNES_W2183: // WMADDH
    pushl %eax
    andb $1,%al
    movb %al,WMADDH
    popl %eax
    ret

// Write to 40xx handlers
ALIGNC
SNES_W4016: // JOYC1
    testb $1,%al
    jz  0f
    pushl %eax
    movb JOYC1,%al
    testb $1,%al
    jnz 1f
    movb $16,%al
    movb %al,Controller1_Pos
    movb %al,Controller23_Pos
    movb %al,Controller45_Pos
1:  popl %eax
0:  movb %al,JOYC1
    ret

ALIGNC
SNES_W4017: // JOYC2
    ret

// Write to 42xx handlers

// SNES_W4200: // NMITIMEN in timing.S

ALIGNC
SNES_W4201: // WRIO
    call UNSUPPORTED_WRITE
    ret

ALIGNC
SNES_W4202: // WRMPYA
    movb %al,WRMPYA
    ret

ALIGNC
SNES_W4203: // WRMPYB
    pushl %eax
    movb %al,WRMPYB
    mulb WRMPYA // Do the multiplication
    movb %al,RDMPYL
    movb %ah,RDMPYH
    popl %eax
    ret

ALIGNC
SNES_W4204: // WRDIVL
    movb %al,WRDIVL
    ret

ALIGNC
SNES_W4205: // WRDIVH
    movb %al,WRDIVH
    ret

ALIGNC
SNES_W4206: // WRDIVB
    pushl %eax
    pushl %ebx
    pushl %edx
    testb %al,%al
    jz 0f
    xorl %ebx,%ebx
    xorl %edx,%edx      // Divide uses DX:AX / BX
    movb %al,%bl
    movb WRDIVL,%al
    movb WRDIVH,%ah
    divw %bx            /* Result is ax=quotient,dx=remainder */
    movb %al,RDDIVL
    movb %ah,RDDIVH
    movb %dl,RDMPYL
    movb %dh,RDMPYH
0:  popl %edx
    popl %ebx
    popl %eax
    ret

// SNES_W4207: // HTIMEL in timing.S
// SNES_W4208: // HTIMEH in timing.S
// SNES_W4209: // VTIMEL in timing.S
// SNES_W420A: // VTIMEH in timing.S
// SNES_W420B: // MDMAEN in DMA.S
// SNES_W420C: // HDMAEN in DMA.S

ALIGNC
SNES_W420D: // MEMSEL   // FastROM switch
    pushl %eax
    andl $1,%eax
//  shll $0x17,%eax // Set bit 7 of bank to switch flag
    shll $7,%eax    // Set bit 7 to switch flag

    testb %al,(__65816_PB_Shifted+2)    // Check bus speed against PB
    movl %eax,MEMSEL
    movb $5,%al
    jnz 0f
    movb $4,%al
0:  movb %al,CycleTable // Update bus speed

    popl %eax
    ret

ALIGNC
SNES_W4210: // RDNMI
    movb $2,RDNMI           // NMI on/off + version
    ret

ALIGNC
SNES_W4211: // TIMEUP
    movb $0,TIMEUP
    andb $0x1F,IRQ_pin
    ret

// Write to 43xx handlers
// SNES_W43xx: // in DMA.S

.text; ALIGNC
.data; ALIGND
.bss; ALIGND
