#ifndef SNEeSe_screen_i
#define SNEeSe_screen_i

.macro	WIPE_SNES_SCREEN
	movl _BKG,%edi
    xorl %eax,%eax
    movl $((256+64)*240+64)/4,%ecx
    rep
    stosl
.endm

.macro SyncRender
    movl Ready_Line_Render,%edi
    subl Current_Line_Render,%edi
    jbe  9f
    call Sync_Render
9:
.endm

.macro RenderScanline
    incl Ready_Line_Render
/*  movl Ready_Line_Render,%eax
    incl %eax
    movl BG1VOFS,%ebx
    movl %eax,Ready_Line_Render
    movl BG1HOFS,%esi
    movw %bx,LineBG1OFS+0(,%eax,4)
    movl BG2VOFS,%edi
    movw %si,LineBG1OFS+4(,%eax,4)
    movl BG2HOFS,%ebx
    movw %di,LineBG2OFS+0(,%eax,4)
    movl BG3VOFS,%esi
    movw %bx,LineBG2OFS+4(,%eax,4)
    movl BG3HOFS,%edi
    movw %si,LineBG3OFS+0(,%eax,4)
    movl BG4VOFS,%ebx
    movw %di,LineBG3OFS+4(,%eax,4)
    movl BG4HOFS,%esi
    movw %bx,LineBG4OFS+0(,%eax,4)
    movw %si,LineBG4OFS+4(,%eax,4)*/
/*  movl ScreenDestPtr,%edi
    xorl %eax,%eax
    movl $256/32,%ebp

ALIGNC
0:  leal 16(%edi),%esi
    movl %eax,(%edi)
    movl %eax,4(%edi)
    movl %eax,8(%edi)
    movl %eax,12(%edi)
    movl %eax,(%esi)
    leal 16(%esi),%edi
    movl %eax,4(%esi)
    movl %eax,8(%esi)
    movl %eax,12(%esi)
    decl %ebp
    jnz 0b

    movb _INIDISP,%ah
    testb %ah,%ah       // Check for screen off
    jns 1f

    addl $64,%edi       // Point screen to next line
    jmp 2f

1:  movb SCR_TM,%bl     // Get BG status for main screens
    call *Render_Mode
    movb SCR_TS,%bl     // Get BG status for sub screens
    call *Render_Mode
    movl ScreenDestPtr,%edi
    addl $256+64,%edi   // Point screen to next line
2:  movl %edi,ScreenDestPtr*/
.endm

.macro Get_Current_Line
  // parameters: none
  // uses: eax, ebx, 0-label
  // returns: eax

  // Handle vertical mosaic
  movl Current_Line_Mosaic,%eax
  movb Mosaic(%edx),%bl
  testb %bl,%bl
  jnz 0f
  movl Current_Line_Render,%eax
0:// End vertical mosaic
.endm

// v0.25 - One macro for 8x8 and 16x8 tiles
.macro SORT_TILES_8_TALL offset_change=0
    // parameters: edx
    // uses: eax, esi, 0-label
    // returns: ebx, LineAddress, LineAddressY

    Get_Current_Line

.if \offset_change-0
    movl %eax,Current_Line_Offset
.endif

    addl VScroll(%edx),%eax
    shll $3,%eax        // Get screen offset
    movl $0xF8*8,%ebx   // Current line + V scroll * 32words
    andl %eax,%ebx
    movl $8*7,%esi
.if \offset_change-0
    movl %ebx,MapAddress_Base
.endif
    andl $0x07*8,%eax   // Line offset in tile
    subl %eax,%esi
    movl %eax,LineAddress
    movl %esi,LineAddressY
.endm

.macro SORT_TILES_16_TALL
    // parameters: edx
    // uses: eax, esi, 0-label
    // returns: ebx, LineAddress, LineAddressY

    Get_Current_Line

    addl VScroll(%edx),%eax
    shll $2,%eax        // Get screen offset
    movl $0x1F0*4,%ebx  // Current line + V scroll * 32words
    andl %eax,%ebx
    andl $0x0F*4,%eax   // Offset into table of line offsets
    movl $16*8*8+8*7,%esi
    movl Tile_Offset_Table_64_8(%eax),%eax
    subl %eax,%esi
    movl %eax,LineAddress
    movl %esi,LineAddressY
.endm

.macro CALCULATE_MOSAIC_YLINE BGmask
    // uses: eax, edx, ebp, 0-label
    // returns: Current_Line_Mosaic
    movb MOSAIC,%al
    testb $\BGmask,%al
    jz  0f
    testb $0xF0,%al
    jz  0f
    movl Current_Line_Render,%eax
    xorl %edx,%edx
    movl Mosaic_Size,%ebp
    decl %eax
    divl %ebp
    mull %ebp
    incl %eax
    movl %eax,Current_Line_Mosaic
0:
.endm

.macro LOAD_BG_TABLE num
    movl $TableBG\num,%edx
.endm

#endif /* SNEeSe_screen_i */
