#ifndef SNEeSe_SPC_i
#define SNEeSe_SPC_i

#include "regs.i"

.macro Execute_SPC SaveCycles=1
    pusha
.if \SaveCycles-0
    cmpb $0,CPU_Executing
    movl _65c816_Cycles,%eax
    jnz 9f
    movl SNES_Cycles,%eax
9:  // Update CPU and SPC cycles
    movl SPC_last_cycles,%edi
    movl %eax,SPC_last_cycles
    subl %edi,%eax
    addl SPC_CPU_cycles,%eax
.endif

// Optimal ratio (approx): 10.132:1

    // 32:3 - 10.667 : 1
    movl %eax,%ecx              // We don't want to lose cycles..
    andl $(~31),%eax
    shrl $5,%eax                // Divide by 32
    andl $31,%ecx
    leal (%eax,%eax,2),%eax     // Multiply by 3
    movl %ecx,SPC_CPU_cycles    // Save remainder

/*
    // 81:8 - 10.125 : 1
    xorl %edx,%edx
    movl $81,%edi
    divl %edi
    movl %edx,SPC_CPU_cycles    // Save remainder
    leal (,%eax,8),%eax // Multiply by 8
 */
    addl _SPC_Cycles,%eax   // Add new balance of SPC cycles
    movl %eax,_SPC_Cycles
    cmpl %eax,_TotalCycles
    jb 8f
    /* Check for and handle 35-minute wrap */
    testl %eax,%eax
    js  9f
    cmpl $0,_TotalCycles
    jns 9f
    call _Wrap_SPC_Cyclecounter
8:  call SPC_START
9:  popa
.endm

#endif /* SNEeSe_SPC_i */
