/*

 SPC700 opcodes 0x20-0x2F:
    20: CLRP            1,2
    21: TCALL 2         1,8
    22: SET1 dp.1       2,4
    23: BBS dp.1,rel    3,5/7
    24: AND A,dp        2,3
    25: AND A,labs      3,4
    26: AND A,(X)       1,3
    27: AND A,(dp+X)    2,6
    28: AND A,#imm      2,2
    29: AND dp(d),dp(s) 3,6
    2A: OR1 C,/mem.bit  3,5
    2B: ROL dp          2,4
    2C: ROL labs        3,5
    2D: PUSH A          1,4
    2E: CBNE dp,rel     3,5/7
    2F: BRA rel         2,4

*/

/* 20 */
ALIGNC
SPC_CLRP:
    incl _NativePC
    CLR_FLAG_SPC(SPC_FLAG_P)
    movb $0,SPC_PAGE+1
    jmp SPC_BACK

/* 21 */ TCALL 2
/* 22 */ /* SPC_SET1 in SPCmain.S */
/* 23 */ /* SPC_BBS in SPCmain.S */
/* 24 */ SPC_AND_A dp
/* 25 */ SPC_AND_A abs
/* 26 */ SPC_AND_A OXO
/* 27 */ SPC_AND_A OOdp_XOO
/* 28 */
ALIGNC
SPC_AND_A_IM:
    SPC_OP_A_IM AND,SPC_FLAG_NZ

/* 29 */ SPC_AND_mem dp_dp
/* 2A */
ALIGNC
SPC_OR1C:       // Carry flag = Carry flag OR !mem.bit
    ADDR_membit         // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    LOAD_BASE
    jc  SPC_BACK        // C | ~1 = C
    SET_FLAG_SPC (SPC_FLAG_C)   // C | ~0 = 1
    jmp SPC_BACK

/* 2B */ SPC_ROL dp
/* 2C */ SPC_ROL abs
/* 2D */ SPC_PUSH_reg A
/* 2E */
ALIGNC
SPC_CBNE_dp:
    movl SPC_PAGE,%ebx
    movb 1(_NativePC),%bl   // get dp
    GET_BYTE_SPC        // get (dp)
    cmpb %al,_A
    je  9f
    movsbl 2(_NativePC),%eax    // sign extend for addition
    addl $2,_Cycles         // Branch taken
    addl %eax,_NativePC
//  addl $2,_TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
9:  addl $3,_NativePC
    jmp SPC_BACK

/* 2F */
ALIGNC
SPC_BRA:
    movsbl 1(_NativePC),%eax    // sign extend for addition
    addl $2,_NativePC
    addl %eax,_NativePC
    jmp SPC_BACK
