/*

 SPC700 opcodes 0x60-0x6F:
    60: CLRC            1,2
    61: TCALL 6         1,8
    62: SET1 dp.3       2,4
    63: BBS dp.3,rel    3,5/7
    64: CMP A,dp        2,3
    65: CMP A,labs      3,4
    66: CMP A,(X)       1,3
    67: CMP A,(dp+X)    2,6
    68: CMP A,#imm      2,2
    69: CMP dp(d),dp(s) 3,6
    6A: AND1 C,/mem.bit 3,4
    6B: ROR dp          2,4
    6C: ROR labs        3,5
    6D: PUSH Y          1,4
    6E: DBNZ dp,rel     3,5/7
    6F: RET             1,5

*/

/* 60 */
ALIGNC
SPC_CLRC:
    incl _NativePC
    CLR_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* 61 */ TCALL 6
/* 62 */ /* SPC_SET1 in SPCmain.S */
/* 63 */ /* SPC_BBS in SPCmain.S */
/* 64 */ SPC_CMP_A dp
/* 65 */ SPC_CMP_A abs
/* 66 */ SPC_CMP_A OXO
/* 67 */ SPC_CMP_A OOdp_XOO
/* 68 */
ALIGNC
SPC_CMP_A_IM:
    SPC_OP_A_IM CMP,SPC_FLAG_NZC

/* 69 */ SPC_CMP_mem dp_dp
/* 6A */
ALIGNC
SPC_AND1C:      // Carry flag = Carry flag AND !mem.bit
    ADDR_membit         // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    LOAD_BASE
    jnc SPC_BACK        // C & ~0 = C
    CLR_FLAG_SPC (SPC_FLAG_C)   // C & ~1 = 0
    jmp SPC_BACK

/* 6B */ SPC_ROR dp
/* 6C */ SPC_ROR abs
/* 6D */ SPC_PUSH_reg Y
/* 6E */
ALIGNC
SPC_DBNZ_dp:
    movl SPC_PAGE,%ebx
    movb 1(_NativePC),%bl   // get dp
    GET_BYTE_SPC        // get (dp)
    decl %eax
    SET_BYTE_SPC
    testb %al,%al
    jz 9f
    movsbl 2(_NativePC),%eax    // sign extend for addition
    addl $2,_Cycles         // Branch taken
    addl %eax,_NativePC
//  addl $2,_TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
9:  addl $3,_NativePC
    jmp SPC_BACK

/* 6F */
ALIGNC
SPC_RET:
  POP_W
  cmpl $0xFFC0,%eax
  movl %eax,_NativePC
  movl SPC_FFC0_Address,%eax
  jnb 0f
  movl $_SPCRAM,%eax
0:addl %eax,_NativePC
  movl %eax,SPC_Code_Base
  jmp SPC_BACK
