/*

 SPC700 opcodes 0x70-0x7F:
    70: BVS rel         2,2/4
    71: TCALL 7         1,8
    72: CLR1 dp.3       2,4
    73: BBC dp.3,rel    3,5/7
    74: CMP A,dp+X      2,4
    75: CMP A,labs+X    3,5
    76: CMP A,labs+Y    3,5
    77: CMP A,(dp)+Y    2,6
    78: CMP dp,#imm     3,5
    79: CMP (X),(Y)     1,5
    7A: ADDW YA,dp      2,5
    7B: ROR dp+X        2,5
    7C: ROR A           1,2
    7D: MOV A,X         1,2
    7E: CMP Y,dp        2,3
    7F: RETI            1,6

*/

/* 70 */ SPC_BFS BVS,SPC_FLAG_V
/* 71 */ TCALL 7
/* 72 */ /* SPC_CLR1 in SPCmain.S */
/* 73 */ /* SPC_BBC in SPCmain.S */
/* 74 */ SPC_CMP_A Odp_XO
/* 75 */ SPC_CMP_A Oabs_XO
/* 76 */ SPC_CMP_A Oabs_YO
/* 77 */ SPC_CMP_A OOdpO_YO
/* 78 */ SPC_CMP_mem dp_IM
/* 79 */ SPC_CMP_mem OXO_OYO
/* 7A */

ALIGNC
SPC_ADDW_YA_dp:
    ADDR_dp
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    GET_WORD_SPC        // get DP word
    movl _YA,%ebx
    addw %ax,%bx
    lahf
    jno 1f
    SET_FLAG_SPC(SPC_FLAG_V)
1:  STORE_FLAGS_SPC_FROM SPC_FLAG_NHZC,%ah
    movl %ebx,_YA
    jmp SPC_BACK

/* 7B */ SPC_ROR Odp_XO
/* 7C */

ALIGNC
SPC_ROR_A:
    incl _NativePC
    shrb $1,_PSW_B      //MAKE_CARRY
    movb _A,%al
    rcrb $1,%al
    movb %al,_A
    adcb _PSW_B,_PSW_B  //STORE_FLAGS_SPC (SPC_FLAG_C)
    testb %al,%al
    STORE_FLAGS_SPC (SPC_FLAG_NZ)
    jmp SPC_BACK

/* 7D */ SPC_MOV_reg_reg A,X
/* 7E */ SPC_CMP_Y dp
/* 7F */ /* RETI - not yet implemented */
