/*

 SPC700 opcodes 0x80-0x8F:
    80: SETC            1,2
    81: TCALL 8         1,8
    82: SET1 dp.4       2,4
    83: BBS dp.4,rel    3,5/7
    84: ADC A,dp        2,3
    85: ADC A,labs      3,4
    86: ADC A,(X)       1,3
    87: ADC A,(dp+X)    2,6
    88: ADC A,#imm      2,2
    89: ADC dp(d),dp(s) 3,6
    8A: EOR1 C,mem.bit  3,5
    8B: DEC dp          2,4
    8C: DEC labs        3,5
    8D: MOV Y,#imm      2,2
    8E: POP PSW         1,4
    8F: MOV dp,#imm     3,5

*/

/* 80 */
ALIGNC
SPC_SETC:
    incl _NativePC
    SET_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* 81 */ TCALL 8
/* 82 */ /* SPC_SET1 in SPCmain.S */
/* 83 */ /* SPC_BBS in SPCmain.S */
/* 84 */ SPC_ADC_A dp
/* 85 */ SPC_ADC_A abs
/* 86 */ SPC_ADC_A OXO
/* 87 */ SPC_ADC_A OOdp_XOO
/* 88 */
ALIGNC
SPC_ADC_A_IM:
    movb 1(_NativePC),%al
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    addl $2,_NativePC
    MAKE_CARRY
    adcb %al,_A
    lahf
    jno 1f
    SET_FLAG_SPC(SPC_FLAG_V)
1:  STORE_FLAGS_SPC_FROM SPC_FLAG_NHZC,%ah
    jmp SPC_BACK

/* 89 */ SPC_ADC_mem dp_dp
/* 8A */
ALIGNC
SPC_EOR1:       // Carry flag = Carry flag EOR mem.bit
    ADDR_membit         // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    LOAD_BASE
    jnc SPC_BACK        // C = C EOR 0 -> C = C
    CPL_FLAG_SPC (SPC_FLAG_C)   // C = C EOR 1 -> C = !C
    jmp SPC_BACK

/* 8B */ SPC_DEC dp
/* 8C */ SPC_DEC abs
/* 8D */
ALIGNC
SPC_MOV_Y_IM:
    SPC_OP_Y_IM MOV,SPC_FLAG_NZ

/* 8E */
ALIGNC
SPC_POP_PSW:
    incl _NativePC
    POP_B
    RESTOREFLAGS_SPC
    jmp SPC_BACK

/* 8F */
ALIGNC
SPC_MOV_dp_IM:
    ADDR_dp_IM 1,%al    // immediate byte in %al
    SET_BYTE_SPC
    jmp SPC_BACK
