/*

 SPC700 opcodes 0xA0-0xAF:
    A0: EI              1,3
    A1: TCALL 10        1,8
    A2: SET1 dp.5       2,4
    A3: BBS dp.5,rel    3,5/7
    A4: SBC A,dp        2,3
    A5: SBC A,labs      3,4
    A6: SBC A,(X)       1,3
    A7: SBC A,(dp+X)    2,6
    A8: SBC A,#imm      2,2
    A9: SBC dp(d),dp(s) 3,6
    AA: MOV1 C,mem.bit  3,4
    AB: INC dp          2,4
    AC: INC labs        3,5
    AD: CMP Y,#imm      2,2
    AE: POP A           1,4
    AF: MOV (X)+,A      1,4

*/

/* A0 */
ALIGNC
SPC_EI:
    incl _NativePC
    SET_FLAG_SPC(SPC_FLAG_I)
    jmp SPC_BACK

/* A1 */ TCALL 10
/* A2 */ /* SPC_SET1 in SPCmain.S */
/* A3 */ /* SPC_BBS in SPCmain.S */
/* A4 */ SPC_SBC_A dp
/* A5 */ SPC_SBC_A abs
/* A6 */ SPC_SBC_A OXO
/* A7 */ SPC_SBC_A OOdp_XOO
/* A8 */ 
ALIGNC
SPC_SBC_A_IM:
    movb 1(_NativePC),%al
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    addl $2,_NativePC
    MAKE_NOT_CARRY
    sbbb %al,_A
    cmc
    lahf
    jno 1f
    SET_FLAG_SPC(SPC_FLAG_V)
1:  STORE_FLAGS_SPC_FROM SPC_FLAG_NHZC,%ah
    jmp SPC_BACK

/* A9 */ SPC_SBC_mem dp_dp
/* AA */
ALIGNC
SPC_MOV1_C_:        // Carry flag = mem.bit
    ADDR_membit         // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    LOAD_BASE
    jnc 0f
    SET_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK
ALIGNC
0:	CLR_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* AB */ SPC_INC dp
/* AC */ SPC_INC abs
/* AD */
ALIGNC
SPC_CMP_Y_IM:
    SPC_OP_Y_IM CMP,SPC_FLAG_NZC

/* AE */ SPC_POP_reg A
/* AF */
ALIGNC
SPC_MOV_OXOInc_A:
    ADDR_OXOInc
    movb _A,%al
    SET_BYTE_SPC
    jmp SPC_BACK
