/*

 SPC700 opcodes 0xC0-0xCF:
    C0: DI              1,3
    C1: TCALL 12        1,8
    C2: SET1 dp.6       2,4
    C3: BBS dp.6,rel    3,5/7
    C4: MOV dp,A        2,4
    C5: MOV labs,A      3,5
    C6: MOV (X),A       1,4
    C7: MOV (dp+X),A    2,7
    C8: CMP X,#imm      2,2
    C9: MOV labs,X      3,5
    CA: MOV1 mem.bit,C  3,6
    CB: MOV dp,Y        2,4
    CC: MOV labs,Y      3,5
    CD: MOV X,#imm      2,2
    CE: POP X           1,4
    CF: MUL YA          1,9

*/

/* C0 */
ALIGNC
SPC_DI:
    incl _NativePC
    CLR_FLAG_SPC(SPC_FLAG_I)
    jmp SPC_BACK

/* C1 */ TCALL 12
/* C2 */ /* SPC_SET1 in SPCmain.S */
/* C3 */ /* SPC_BBS in SPCmain.S */
/* C4 */ SPC_MOV_mem_A dp
/* C5 */ SPC_MOV_mem_A abs
/* C6 */ SPC_MOV_mem_A OXO
/* C7 */ SPC_MOV_mem_A OOdp_XOO
/* C8 */
ALIGNC
SPC_CMP_X_IM:
    SPC_OP_X_IM CMP,SPC_FLAG_NZC

/* C9 */ SPC_MOV_mem_X abs
/* CA */
ALIGNC
SPC_MOV1__C:        // mem.bit = Carry flag
    ADDR_membit         // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC
    TEST_FLAG_SPC (SPC_FLAG_C)
    jz  0f
    btsl %edx,%eax
    LOAD_BASE
    SET_BYTE_SPC
    jmp SPC_BACK
ALIGNC
0:  btrl %edx,%eax
    LOAD_BASE
    SET_BYTE_SPC
    jmp SPC_BACK

/* CB */ SPC_MOV_mem_Y dp
/* CC */ SPC_MOV_mem_Y abs
/* CD */
ALIGNC
SPC_MOV_X_IM:
    SPC_OP_X_IM MOV,SPC_FLAG_NZ

/* CE */ SPC_POP_reg X
/* CF */
ALIGNC
SPC_MUL:
    incl _NativePC
    movb _Y,%al
    mulb _A
    movl %eax,_YA
    testw %ax,%ax
    STORE_FLAGS_SPC (SPC_FLAG_NZ)
    jmp SPC_BACK
