/*

 SPC700 opcodes 0xE0-0xEF:
    E0: CLRV            1,2
    E1: TCALL 14        1,8
    E2: SET1 dp.7       2,4
    E3: BBS dp.7,rel    3,5/7
    E4: MOV A,dp        2,3
    E5: MOV A,labs      3,4
    E6: MOV A,(X)       1,3
    E7: MOV A,(dp+X)    2,6
    E8: MOV A,#imm      2,2
    E9: MOV X,labs      3,4
    EA: NOT1 mem.bit    3,5
    EB: MOV Y,dp        2,3
    EC: MOV Y,labs      3,4
    ED: NOTC            1,3
    EE: POP Y           1,4
    EF: SLEEP           1,3

*/

/* E0 */
ALIGNC
SPC_CLRV:
    incl _NativePC
    CLR_FLAG_SPC(SPC_FLAG_V+SPC_FLAG_H)
    jmp SPC_BACK

/* E1 */ TCALL 14
/* E2 */ /* SPC_SET1 in SPCmain.S */
/* E3 */ /* SPC_BBS in SPCmain.S */
/* E4 */ SPC_MOV_A_mem dp
/* E5 */ SPC_MOV_A_mem abs
/* E6 */ SPC_MOV_A_mem OXO
/* E7 */ SPC_MOV_A_mem OOdp_XOO
/* E8 */
ALIGNC
SPC_MOV_A_IM:
    SPC_OP_A_IM MOV,SPC_FLAG_NZ

/* E9 */ SPC_MOV_X_mem abs
/* EA */
ALIGNC
SPC_NOT1:       // !mem.bit
    ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC    // Get byte at location
    btcl %edx,%eax  // complement the bit
    LOAD_BASE
    SET_BYTE_SPC    // set byte
    jmp SPC_BACK

/* EB */ SPC_MOV_Y_mem dp
/* EC */ SPC_MOV_Y_mem abs
/* ED */
ALIGNC
SPC_NOTC:
    incl _NativePC
    CPL_FLAG_SPC(SPC_FLAG_C)
    jmp SPC_BACK

/* EE */ SPC_POP_reg Y
/* EF */
ALIGNC
SPC_SLEEP:
    jmp SPC_BACK            // What else can sleep do?
